//+X================================================================X+
//|                                                      Exp_17R.mq4 |
//|                             Copyright  2009,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+
#property copyright "Copyright  2009, Nikolay Kositsin"
#property link "farria@mail.redcom.ru"
//+---------------------------------------------+
//| INPUT PARAMETERS OF THE EXPERT ADVISOR FOR BUY DEALS   |
//+---------------------------------------------+
extern bool   Test_Up = true;//filter of direction of deal calculations
extern int    Timeframe_Up = 240;
extern double Money_Management_Up = 0.1;
extern int    Length_Up = 4;  // depth of smoothing 
extern int    Phase_Up = 100; // parameter that varies within the range 
          //-100 ... +100, impacts the transitional process quality; 
extern int    IPC_Up = 0;/* Prices based on which 
the indicator is calculated (0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 
6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW.) */
extern int    ATR_Period_Up = 14; // True Range averaging period 
extern int    LevMinimum_Up = 40; // Minimum value in points below
                          // which pending order values cannot fall
extern int    STOPLOSS_Up = 100;  // Stop Loss expressed as percentage of ATR
extern int    TAKEPROFIT_Up = 200; // Take Profit expressed as percentage of ATR
extern int    TRAILINGSTOP_Up = 100; // Trailing Stop expressed as percentage of ATR
extern bool   ClosePos_Up = true; // permission to forcibly close a position
//+---------------------------------------------+
//| INPUT PARAMETERS OF THE EXPERT ADVISOR FOR SELL DEALS  |
//+---------------------------------------------+
extern bool   Test_Dn = true;//filter of direction of deal calculations
extern int    Timeframe_Dn = 240;
extern double Money_Management_Dn = 0.1;
extern int    Length_Dn = 4;  // depth of smoothing 
extern int    Phase_Dn = 100; // parameter that varies within the range
         // -100 ... +100, impacts the transitional process quality; 
extern int    IPC_Dn = 0;/* Prices based on which 
the indicator is calculated (0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 
6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW.) */
extern int    ATR_Period_Dn = 14; // True Range averaging period
extern int    LevMinimum_Dn = 40; // Minimum value in points below
                          // which pending order values cannot fall
extern int    STOPLOSS_Dn = 100;  // Stop Loss expressed as percentage of ATR
extern int    TAKEPROFIT_Dn = 200; // Take Profit expressed as percentage of ATR
extern int    TRAILINGSTOP_Dn = 100; // Trailing Stop expressed as percentage of ATR
extern bool   ClosePos_Dn = true; // permission to forcibly close a position
//+---------------------------------------------+
//---- declaration of logical variable to correctly complete the initialization
bool INIT;
//---- declaration of integer variables for the minimum calculation bars
int MinBar_Up, MinBar_Dn;
//---- declaration of integer variables for chart time frames in seconds
int Period_Up, Period_Dn;
//---- declaration of floating point variables for pending orders
double _STOPLOSS_Up, _TAKEPROFIT_Up, _LevMinimum_Up, _TRAILINGSTOP_Up; 
double _STOPLOSS_Dn, _TAKEPROFIT_Dn, _LevMinimum_Dn, _TRAILINGSTOP_Dn;
//Version  November 26, 2007
//+X================================================================X+
//|                                                 iPriceSeries.mqh |
//|                        Copyright  2007,        Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+
/*                                                                   |
 The PriceSeries() function returns the input price of a bar by its    |
 Bar number and IPC price number:                                           |
 0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL,                |
 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW,            |
 10-0.5 * TRENDFOLLOW.                                               |
 example: minuse = iPriceSeries("GBPJPY", 240, IPC, bar)              |
                  - iPriceSeries("GBPJPY", 240, IPC, bar + 1);       |
*/                                                              //   |
//+X================================================================X+   
//| iPriceSeries() function                                          |
//+X================================================================X+ 
double iPriceSeries(string symbol, int timeframe,int IPC, int Bar)
 {
  double diPriceSeries; 
  switch(IPC) 
  {
   case  0: diPriceSeries = iClose(symbol, timeframe, Bar); break;
   case  1: diPriceSeries = iOpen (symbol, timeframe, Bar); break;
   case  2: diPriceSeries = iHigh (symbol, timeframe, Bar); break;
   case  3: diPriceSeries = iLow  (symbol, timeframe, Bar); break;
   //----+
   case  4: diPriceSeries = 
             (iHigh (symbol, timeframe, Bar) + iLow  (symbol, timeframe, Bar)) / 2; break;
   //----+
   case  5: diPriceSeries = 
             (iClose(symbol, timeframe, Bar) + iHigh (symbol, timeframe, Bar)
                                              + iLow (symbol, timeframe, Bar)) / 3; break;
   //----+                                                                  
   case  6: diPriceSeries = 
             (iOpen (symbol, timeframe, Bar)+iHigh (symbol, timeframe, Bar)
               + iLow (symbol, timeframe, Bar)+iClose(symbol, timeframe, Bar)) / 4; break;
   //----+                                 
   case  7: diPriceSeries = 
               (iOpen (symbol, timeframe, Bar)+iClose(symbol, timeframe, Bar)) / 2; break;
   //----+
   case  8: diPriceSeries = 
               (iClose(symbol, timeframe, Bar)+iHigh (symbol, timeframe, Bar)
                + iLow(symbol, timeframe, Bar)+iClose(symbol, timeframe, Bar)) / 4; break;
   //----+                                
   case  9: diPriceSeries = iTrendFollow00(symbol, timeframe, Bar); break;
   case 10: diPriceSeries = iTrendFollow01(symbol, timeframe, Bar); break;
   //----+
   default: diPriceSeries = iClose(symbol, timeframe, Bar);
  }
return(diPriceSeries);
 }
//+X================================================================X+   
//| iPriceSeriesAlert() function                                     |
//+X================================================================X+
/*
The iPriceSeriesAlert() function is intended for indicating an invalid 
IPC parameter value passed to the iPriceSeries() function.
*/
void iPriceSeriesAlert(int IPC)
  {
    if (IPC < 0)
     Alert(StringConcatenate
        ("The IPC parameter value must be not less than 0", 
           " You have entered the invalid value ", IPC, " 0 will be used"));
    //----+                     
    if (IPC > 10)
     Alert(StringConcatenate
        ("The IPC parameter value must not exceed 10", 
           " You have entered the invalid value ", IPC, " 0 will be used"));
  }
//+X================================================================X+   
//| iTrendFollow00() function                                        |
//+X================================================================X+
double iTrendFollow00(string symbol, int timeframe, int Bar)
 {
   double diTrendFollow00;
   double high = iHigh  (symbol, timeframe, Bar);
   double low =  iLow   (symbol, timeframe, Bar);
   double open = iOpen  (symbol, timeframe, Bar);
   double close = iClose(symbol, timeframe, Bar);
   //----
   if(close > open)
        diTrendFollow00 = high;
   else
    {
     if(close < open)
          diTrendFollow00 = low;
     else diTrendFollow00 = close;
    }
    
   return(diTrendFollow00);
 }
//+X================================================================X+   
//| iTrendFollow01() function                                        |
//+X================================================================X+
double iTrendFollow01(string symbol, int timeframe, int Bar)
 {
   double diTrendFollow01;
   double high = iHigh  (symbol, timeframe, Bar);
   double low =  iLow   (symbol, timeframe, Bar);
   double open = iOpen  (symbol, timeframe, Bar);
   double close = iClose(symbol, timeframe, Bar);
   //----
   if(close > open)
         diTrendFollow01 = (high + close) / 2;
   else
    {
     if(close < open)
          diTrendFollow01 = (low + close) / 2;
     else diTrendFollow01 =  close;
    }
   
  return(diTrendFollow01);
 }
//+X================================================================X+
//| JFATL() function                                                 |
//+X================================================================X+  
bool JFATL(int Number, string symbol, int timeframe,
               int Length, int Phase, int IPC, double& Buffer[])
  {
//----+
   //----+
   static bool SecondStart;
   static int FilterSize, StartBar;
   //+--- Initialization of the coefficients of the digital filter 
   static double Filter[] =
    {                                                           
     +0.4360409450, +0.3658689069, +0.2460452079, +0.1104506886, 
     -0.0054034585, -0.0760367731, -0.0933058722, -0.0670110374, 
     -0.0190795053, +0.0259609206, +0.0502044896, +0.0477818607, 
     +0.0249252327, -0.0047706151, -0.0272432537, -0.0338917071, 
     -0.0244141482, -0.0055774838, +0.0128149838, +0.0226522218, 
     +0.0208778257, +0.0100299086, -0.0036771622, -0.0136744850, 
     -0.0160483392, -0.0108597376, -0.0016060704, +0.0069480557, 
     +0.0110573605, +0.0095711419, +0.0040444064, -0.0023824623, 
     -0.0067093714, -0.0072003400, -0.0047717710, +0.0005541115,
     +0.0007860160, +0.0130129076, +0.0040364019
    }; 

   //---- Initialization to zero
   if (Number < 0)
    {
     if (!SecondStart)
      {
       int size = MathAbs(Number);
       if (JJMASeries1Resize(size) != size)
        {
         PlaySound("alert.wav");
         Print("JFATL(): Failed to allocate memory for variables!!!");
         return(false);
        }
       //---- initialization of variables 
       SecondStart = true;
       FilterSize = ArraySize(Filter);
       StartBar = FilterSize + 30; // FATL filter length + JMA filter length
       Print("JFATL(): Memory for variables has been allocated!!!");
       return(true);
      }
     else return(true);
    }
   
   //---- getting the number of all bars
   int _Bars = iBars(symbol, timeframe);
   //---- checking for the sufficiency of the number of bars for the calculation
	if (_Bars <= StartBar)
			     return(true);
   _Bars--; 
      
   //---- Indicator buffer emulation 
   if (!ReSetAsIndexBuffer(symbol, timeframe, Buffer))
                                              return(false);
    	
   //---- declaration of floating point variables 
   double FATL, JFATL;
   //---- declaration of integer variables and getting the bars already counted
   int limit, reset, MaxBar; 
   int bar, counted_bars = IndicatorCounted_(Number, symbol, timeframe);
   //---- check for possible errors
   if (counted_bars < 0)
               return(false);
   //---- determine the number of the oldest bar 
               //starting from which the new bars will be recounted
   limit = _Bars - counted_bars; 
   //---- determine the number of the oldest bar 
                //starting from which all bars will be recounted
   MaxBar = _Bars - FilterSize;
   //----
   if (limit > MaxBar)
               limit = MaxBar;
   //----
   for(bar = limit; bar >= 1; bar--)
    {
	  //----+ formula for the FATL filter
	  FATL = 0.0;
	  for(int ii = 0; ii < FilterSize; ii++)
		 FATL += Filter[ii] * iPriceSeries(symbol, timeframe, IPC, bar + ii);
	  
	  //----+ JMA smoothing of the resulting indicator, 
						   // the nJMA.MaxBar parameter decreased by the size of FilterSize
	                  // Calling the JJMASeries function for the Number number, 
			  // the nJMA.Phase and nJMA.Length parameters do not change on every bar (nJMA.din = 0)
	  JFATL = JJMASeries1(Number, 0, MaxBar, limit, Phase, Length, FATL, bar, reset);
	  //----+ check for errors in the previous operation
	  if(reset != 0)
				  return(false);
	  //----			  
	  Buffer[bar] = JFATL;
	  //----
    }
   //---- End of the JFATL() function
   return(true);
//----+ 
  }
//+X================================================================X+
//| JFATLResize() function                                           |
//+X================================================================X+  
bool JFATLResize(int JFATLSize)
  {
//----+
   //----+
   double Arr[2];
   //---- Allocation of memory for static 
                                     // variables of the JFATL() function
   if (!JFATL(-MathAbs(JFATLSize), NULL, 0, 0, 0, 0, Arr))
                                                 return(false);
   //---- End of the JFATLResize() function
   return(true);
//----+ 
  }
//Version  January 20, 2009
//+X================================================================X+
//|                                                 Lite_EXPERT2.mqh |
//|                             Copyright  2009,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+

//---- Declaring an external variable for slippage in points 
extern int Slippage_ = 3;   
                                
//---- Declaring a global variable for storing 
                            //the time of the last server call 
int LastTime;

//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+   
/*                                                                   |
 The Margin_Mode external variable determines the lot size | 
 calculation                                                                |
 0 - MM based on free margin                              |
 1 - MM based on the account balance                                  |
 2 - MM based on losses on free margin                     |
 3 - MM based on losses on the account balance                       |
 4 - minimum lot between 0 and 2                                     |
 5 - minimum lot between 1 and 3                                     |
 by default - MM based on free margin                   |
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
 if Money_Management is negative, the trading function uses | 
 the absolute Money_Management value rounded to the nearest standard value |
 as the lot size.                      |
*/                                                                // |
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+

//+X================================================================X+
//| dOpenBuyOrder1_()                                                |
//+X================================================================X+
bool dOpenBuyOrder1_
        (bool& BUY_Signal, int MagicNumber, datetime TimeLevel,
                           double Money_Management, int Margin_Mode, 
                                  double dSTOPLOSS, double dTAKEPROFIT)
 {
//---+
  if (!BUY_Signal)
           return(true); 
  //---- Check if the minimum time interval has passed 
                                    //between two trading operations         
  if (TimeCurrent() < LastTime)
                          return(true); 
  //----
  string Symb = Symbol();
  
  //---- Check if the time limit with respect to the previous deal has expired
  if (!TradeTimeLevelCheck(Symb, MagicNumber, TimeLevel))
                                                  return(true);
                                 
  //---- Check for an open position 
          //with the magic number equal to the MagicNumber variable value
  if (Order_Select(Symb, MagicNumber))
                                 return(true);  
  //----
  string OpderPrice;
  bool   Order_Select;
  int    STOPLOSS, TAKEPROFIT ; 
  int    ErrorCode, ticket, StLOSS, TkPROFIT;
  double Lot, ask, Stoploss, TakeProfit;
  //----          
  ask = NormalizeDouble(Ask, Digits);
  if (ask == 0.0)
          return(false);  
  //----
  if (dSTOPLOSS > 0)
       STOPLOSS = (ask - dSTOPLOSS) / Point;
  else STOPLOSS = 0;
  //----
  if (dTAKEPROFIT > 0)
       TAKEPROFIT = (dTAKEPROFIT - ask) / Point;
  else TAKEPROFIT = 0;
  //----      
                                                           
  //---+ LOT SIZE CALCULATION FOR OPENING A POSITION
  Lot = BuyLotCount(Money_Management, Margin_Mode, STOPLOSS);
  //----
  if (Lot == -1)
            return(false);  
  else 
   if (Lot == 0)
             return(true);  
        
  //---+ check the lot size against the funds available in the account   
  if (!MarginCheck(Symb, OP_BUY, Lot))
                                  return(false);
  //----
  if (Lot == 0.0)
            return(true);   
  //---- 
  if (STOPLOSS > 0) 
   {           
     StLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
     if (StLOSS < 0)
          return(false);
     //----
     Stoploss = NormalizeDouble(ask - StLOSS * Point, Digits);
     if (Stoploss < 0)
           return(false);
     //---- 
   }
  else 
   {
    if (STOPLOSS < 0)
         Print("dOpenBuyOrder1_(): Invalid Stop Loss!!!");
    Stoploss = 0.0;
   }
  //----   
  if (TAKEPROFIT > 0) 
   {           
     TkPROFIT = StopCorrect(Symb, TAKEPROFIT, Slippage_);
     if (TkPROFIT < 0)
          return(false);
     //----
     TakeProfit = NormalizeDouble(ask + TkPROFIT * Point, Digits);
     if (TakeProfit < 0)
                return(false);
     //---- 
   }  
  else 
   {
    if (TAKEPROFIT < 0)
         Print("dOpenBuyOrder1_(): Invalid Take Profit!!!");
    TakeProfit = 0.0;
   }
  //----      
  Print(StringConcatenate
         ("Open a ", Symb,
            " Buy position with the magic number ", MagicNumber));
            
  //---+ Open a Buy position    
  ticket = OrderSend(Symb, OP_BUY, Lot, ask, Slippage_, 
            Stoploss, TakeProfit, NULL, MagicNumber, 0, Lime);
  
  //---- Calculation of the time interval between trading operations         
  CountLastTime(GetLastError());
  //----
  Order_Select = OrderSelect(ticket, SELECT_BY_TICKET);
  
  //---- Calculation of the time interval between trading operations         
  ReCountLastTime(GetLastError());
  //----
  if(ticket > 0)
   {
     if (Order_Select)
       {
         //---- Blocking the dOpenBuyOrder1_() function
                            // from repeated performance of the operation
         if(TimeLevel < 0)
                   BUY_Signal = false;
         //----
         if(TimeLevel > 0)
            GlobalVariableSet(GetTimeLevelName(Symb, MagicNumber), TimeLevel);
         //----
         OpderPrice = DoubleToStr(OrderOpenPrice(), Digits);  
         Print(StringConcatenate(Symb, " BUY order with ticket #",
                ticket, " and magic number ", OrderMagicNumber(), 
                                         " opened at the price ",OpderPrice));                                
       }
     else Print(StringConcatenate("Failed to open ", Symb, 
           " BUY order with the magic number ", MagicNumber, "!!!"));
   }
  else Print(StringConcatenate("Failed to open ", Symb, 
           " BUY order with the magic number ", MagicNumber, "!!!"));
  //---- 
  return(true);
//---+
 }
//+X================================================================X+
//| dOpenSellOrder1_()                                               |
//+X================================================================X+
bool dOpenSellOrder1_
        (bool& SELL_Signal, int MagicNumber, datetime TimeLevel,
                           double Money_Management, int Margin_Mode, 
                                  double dSTOPLOSS, double dTAKEPROFIT)
 {
//---+
  if (!SELL_Signal)
           return(true); 
  //---- Check if the minimum time interval has passed 
                                    //between two trading operations         
  if (TimeCurrent() < LastTime)
                          return(true);                    
  //----
  string Symb = Symbol();

  //---- Check if the time limit with respect to the previous deal has expired
  if (!TradeTimeLevelCheck(Symb, MagicNumber, TimeLevel))
                                                  return(true); 
                                 
  //---- Check for an open position 
          //with the magic number equal to the MagicNumber variable value
  if (Order_Select(Symb, MagicNumber))
                                 return(true);  
  //----
  string OpderPrice;
  bool   Order_Select;
  int    STOPLOSS, TAKEPROFIT; 
  int    ticket, StLOSS, TkPROFIT, ErrorCode;
  double Lot, bid, Stoploss, TakeProfit;
  //----
  bid = NormalizeDouble(Bid, Digits);
  if (bid == 0.0)
          return(false);
  //----
  if (dSTOPLOSS > 0)
       STOPLOSS = (dSTOPLOSS - bid) / Point;
  else STOPLOSS = 0;
  //----
  if (dTAKEPROFIT > 0)
       TAKEPROFIT = (bid - dTAKEPROFIT) / Point;
  else TAKEPROFIT = 0;                                                                                                                                          
  
  //---+ LOT SIZE CALCULATION FOR OPENING A POSITION
  Lot = SellLotCount(Money_Management, Margin_Mode, STOPLOSS);
  //----
  if (Lot == -1)
            return(false);  
  else 
   if (Lot == 0)
             return(true);  
          
  //---+ check the lot size against the funds available in the account   
  if (!MarginCheck(Symb, OP_SELL, Lot))
                                  return(false);
  //----
  if (Lot == 0.0)
            return(true);
  //---- 
  if (STOPLOSS > 0) 
   {           
     StLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
     if (StLOSS < 0)
          return(false);
     //----
     Stoploss = NormalizeDouble(bid + StLOSS * Point, Digits);
     if (Stoploss < 0)
           return(false);
     //---- 
   }
  else 
   {
    if (STOPLOSS < 0)
         Print("dpenSellOrder1_(): Invalid Stop Loss!!!");
    Stoploss = 0.0;
   } 
  //----   
  if (TAKEPROFIT > 0) 
   {           
     TkPROFIT = StopCorrect(Symb, TAKEPROFIT, Slippage_);
     if (TkPROFIT < 0)
          return(false);
     //----
     TakeProfit = NormalizeDouble(bid - TkPROFIT * Point, Digits);
     if (TakeProfit < 0)
           return(false);
     //---- 
   }
  else 
   {
    if (TAKEPROFIT < 0)
         Print("dpenSellOrder1_(): Invalid Take Profit!!!");
    TakeProfit = 0.0;
   }
  //---- 
  Print(StringConcatenate
         ("Open a ", Symb,
               " Sell position with the magic number ", MagicNumber)); 
                  
  //---+ Open a Sell position    
  ticket = OrderSend(Symb, OP_SELL, Lot, bid, Slippage_, 
            Stoploss, TakeProfit, NULL, MagicNumber, 0, Red);
              
  //---- Calculation of the time interval between trading operations         
  CountLastTime(GetLastError());
  //----
  Order_Select = OrderSelect(ticket, SELECT_BY_TICKET);
  
  //---- Calculation of the time interval between trading operations         
  ReCountLastTime(GetLastError());
  //----
  if(ticket > 0)
   {
     if (Order_Select)
       {
         //---- Blocking the dOpenSellOrder1_() function
                            // from repeated performance of the operation
         if(TimeLevel < 0)
                   SELL_Signal = false;
         //----
         if(TimeLevel > 0)
            GlobalVariableSet(GetTimeLevelName(Symb, MagicNumber), TimeLevel);
         //----
         OpderPrice = DoubleToStr(OrderOpenPrice(), Digits);  
         Print(StringConcatenate(Symb, " SELL order with ticket #",
                 ticket, " and magic number ", OrderMagicNumber(), 
                                            " opened at the price " ,OpderPrice));
       }
     else Print(StringConcatenate("Failed to open ", Symb, 
              " SELL order with the magic number ", MagicNumber, "!!!"));
    }
   else Print(StringConcatenate("Failed to open ", Symb, 
              " SELL order with the magic number ", MagicNumber, "!!!"));
  //----  
  return(true);
//---+  
 }
//+X================================================================X+
//| dOpenBuyOrder2_()                                                |
//+X================================================================X+
bool dOpenBuyOrder2_
        (bool& BUY_Signal, int MagicNumber, datetime TimeLevel,
                           double Money_Management, int Margin_Mode, 
                                   double dSTOPLOSS, double dTAKEPROFIT)
 {
//---+
  //---- Check if the minimum time interval has passed 
                                    //between two trading operations         
  if (TimeCurrent() < LastTime)
                          return(true); 
  //----                        
  bool IfOrderExists;
  static bool IfOrderModify[];
  //----
  if (ArraySize(IfOrderModify) < MagicNumber + 1) 
                    ArrayResize(IfOrderModify, MagicNumber + 1); 
  //----
  if (!BUY_Signal)
   if (IfOrderModify[MagicNumber])
                        return(true);                  
  //----
  string Symb = Symbol();

  //---- Check if the time limit with respect to the previous deal has expired
  if (!TradeTimeLevelCheck(Symb, MagicNumber, TimeLevel))
                                                  return(true); 
  //----
  int STOPLOSS, TAKEPROFIT; 
  //----
  if (dSTOPLOSS > 0)
       STOPLOSS = (Ask - dSTOPLOSS) / Point;
  else STOPLOSS = 0;
  //----
  if (dTAKEPROFIT > 0)
       TAKEPROFIT = (dTAKEPROFIT - Ask) / Point;
  else TAKEPROFIT = 0;
  
  //---- Check for an open position with set Stop Loss and Take Profit
                       //with the magic number equal to the MagicNumber variable value    
  if (Order_Select(Symb, MagicNumber))
    {
      if (OrderType() != OP_BUY)
                            return(true);
      IfOrderExists = true;
      //----
      if ((OrderTakeProfit() == 0 && TAKEPROFIT != 0)
            || (OrderStopLoss() == 0 && STOPLOSS != 0))                                                  
                          IfOrderModify[MagicNumber] = false;
      else
       if (OrderStopLoss() != 0 
               && OrderTakeProfit() != 0)
        {
         IfOrderModify[MagicNumber] = true;
         return(true);
        }    
    }
  else 
    if (!BUY_Signal)
     {
      IfOrderModify[MagicNumber] = true;
      return(true);
     }
  //---- 
  string OpderPrice;
  bool   Order_Modify, Order_Select;
  int    ticket, StLOSS, TkPROFIT, ErrorCode;
  double Lot, ask, Stoploss, TakeProfit;                                                 
  //----
  if (BUY_Signal && !IfOrderExists)
   {                                                                                  
    //---+ LOT SIZE CALCULATION FOR OPENING A POSITION
    Lot = BuyLotCount(Money_Management, Margin_Mode, STOPLOSS);
    //----
    if (Lot == -1)
              return(false);  
    else 
     if (Lot == 0)
               return(true);
               
    //---+ check the lot size against the funds available in the account   
    if (!MarginCheck(Symb, OP_BUY, Lot))
                               return(false);
    //----
    if (Lot == 0.0)
            return(true);
    //----
    ask = NormalizeDouble(Ask, Digits);
    if (ask == 0.0)
          return(false);
    //---- 
    Print(StringConcatenate
         ("Open a ", Symb,
                       " Buy position with the magic number ", MagicNumber));
    //---+ Open a Buy position    
    ticket = OrderSend(Symb, OP_BUY, Lot, ask, Slippage_, 0, 0, NULL, MagicNumber, 0, Lime); 
     
    //---- Calculation of the time interval between trading operations         
    CountLastTime(GetLastError());
    //----
    Order_Select = OrderSelect(ticket, SELECT_BY_TICKET);
  
    //---- Calculation of the time interval between trading operations         
    ReCountLastTime(GetLastError());
    //----
    if(ticket > 0)
     {
     if (Order_Select)
       {
         //---- Blocking the dOpenBuyOrder2_() function
                            // from repeated performance of the operation
         if(TimeLevel < 0)
                   BUY_Signal = false;
         //----
         if(TimeLevel > 0)
            GlobalVariableSet(GetTimeLevelName(Symb, MagicNumber), TimeLevel);
         //----
         OpderPrice = DoubleToStr(OrderOpenPrice(), Digits);  
         Print(StringConcatenate(Symb, " BUY order with ticket #",
                      ticket, " and magic number ", OrderMagicNumber(), 
                                                     " opened at the price ",OpderPrice));
         //----
         IfOrderModify[MagicNumber] = false;
       }
      else
       {
         Print(StringConcatenate("Failed to open ", Symb, 
                            " BUY order with the magic number ", MagicNumber, "!!!"));
         return(true);
       }
     }
    else
     {
       Print(StringConcatenate("Failed to open ", Symb, 
                         " BUY order with the magic number ", MagicNumber, "!!!"));
       return(true);
     }
   }
  //---+ Open order modification 
  if (!IfOrderModify[MagicNumber])
   {   
    if (STOPLOSS == 0 && TAKEPROFIT == 0)
     {
      IfOrderModify[MagicNumber] = true;
      return(true);
     }
    //----       
    if (STOPLOSS > 0) 
     {           
      StLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
      if (StLOSS < 0)
           return(false);
      //----
      Stoploss = NormalizeDouble(OrderOpenPrice() - StLOSS * Point, Digits);  
      if (Stoploss < 0)
           return(false);
     }
    else 
     {
      if (STOPLOSS < 0)
           Print("dOpenBuyOrder2_(): Invalid Stop Loss!!!");
      Stoploss = 0.0;
     }
    //----   
    if (TAKEPROFIT > 0) 
     {           
      TkPROFIT = StopCorrect(Symb, TAKEPROFIT, Slippage_);
      if (TkPROFIT < 0)
          return(false);
      //----
      TakeProfit = NormalizeDouble(OrderOpenPrice() + TkPROFIT * Point, Digits);
      if (TakeProfit < 0)
               return(false);
     }
    else 
     {
      if (TAKEPROFIT < 0)
           Print("dOpenBuyOrder2_(): Invalid Take Profit!!!");
      TakeProfit = 0.0;
     }
    //----     
    Print(StringConcatenate
         ("Modify the ", Symb,
                       " BUY order with ticket #", OrderTicket(), 
                                             " with the magic number ", MagicNumber));       
    //----
    Order_Modify = OrderModify(OrderTicket(), 
                    OrderOpenPrice(), Stoploss, TakeProfit, 0, Blue);
                    
    //---- Calculation of the time interval between trading operations         
    CountLastTime(GetLastError());
    //----                      
    if (Order_Modify)
     {
       Print(StringConcatenate(Symb, " BUY order with ticket #",
                                         OrderTicket(), " and the magic number ", 
                                             OrderMagicNumber(), " has been modified"));
       //----
       IfOrderModify[MagicNumber] = true;                                     
     }
    else Print(StringConcatenate("Failed to modify the BUY ", 
                            Symb, " order with ticket #", OrderTicket(), 
                                  " and the magic number ", OrderMagicNumber()));     
   }
    
  return(true);
//---+
 }
//+X================================================================X+
//| dOpenSellOrder2_()                                               |
//+X================================================================X+
bool dOpenSellOrder2_
        (bool& SELL_Signal, int MagicNumber, datetime TimeLevel, 
                            double Money_Management, int Margin_Mode, 
                                   double dSTOPLOSS, double dTAKEPROFIT)
 {
//---+
  //---- Check if the minimum time interval has passed 
                                    //between two trading operations         
  if (TimeCurrent() < LastTime)
                          return(true); 
  //----                        
  bool IfOrderExists;
  static bool IfOrderModify[];
  //----
  if (ArraySize(IfOrderModify) < MagicNumber + 1) 
                    ArrayResize(IfOrderModify, MagicNumber + 1); 
  //----
  if (!SELL_Signal)
   if (IfOrderModify[MagicNumber])
                        return(true);                  
  //----
  string Symb = Symbol();

  //---- Check if the time limit with respect to the previous deal has expired
  if (!TradeTimeLevelCheck(Symb, MagicNumber, TimeLevel))
                                                  return(true); 
  //----
  int STOPLOSS, TAKEPROFIT;
  //----
  if (dSTOPLOSS > 0)
       STOPLOSS = (dSTOPLOSS - Bid) / Point;
  else STOPLOSS = 0;
  //----
  if (dTAKEPROFIT > 0)
       TAKEPROFIT = (Bid - dTAKEPROFIT) / Point;
  else TAKEPROFIT = 0; 
  
  //---- Check for an open position with set Stop Loss and Take Profit
                       //with the magic number equal to the MagicNumber variable value    
  if (Order_Select(Symb, MagicNumber))
    {
      if (OrderType() != OP_SELL)
                            return(true);
      IfOrderExists = true;
      //----
      if ((OrderTakeProfit() == 0 && TAKEPROFIT != 0)
            || (OrderStopLoss() == 0 && STOPLOSS != 0))                                                  
                          IfOrderModify[MagicNumber] = false;
      else
       if (OrderStopLoss() != 0 && OrderTakeProfit() != 0) 
        {
         IfOrderModify[MagicNumber] = true;
         return(true);
        }    
    }
  else 
    if (!SELL_Signal)
     {
      IfOrderModify[MagicNumber] = true;
      return(true);
     }
  //----       
  string OpderPrice;
  bool   Order_Modify, Order_Select; 
  int    ticket, StLOSS, TkPROFIT, ErrorCode;
  double Lot, bid, Stoploss, TakeProfit;                                                                                                  
  //----
  if (SELL_Signal && !IfOrderExists)
   {                                
    //---+ LOT SIZE CALCULATION FOR OPENING A POSITION
    Lot = SellLotCount(Money_Management, Margin_Mode, STOPLOSS);
    //----
    if (Lot == -1)
              return(false);  
    else 
     if (Lot == 0)
               return(true);
          
    //---+ check the lot size against the funds available in the account   
    if (!MarginCheck(Symb, OP_SELL, Lot))
                                    return(false);
    //----
     if (Lot == 0.0)
            return(true);
    //----
    bid = NormalizeDouble(Bid, Digits);
    if (bid == 0.0)
            return(false);
  
    Print(StringConcatenate
           ("Open a ", Symb,
                       " Sell position with the magic number ", MagicNumber));    
    //---+ Open a Sell position    
    ticket = OrderSend(Symb, OP_SELL, Lot, bid, 
                        Slippage_, 0, 0, NULL, MagicNumber, 0, Red); 
     
    //---- Calculation of the time interval between trading operations         
    CountLastTime(GetLastError());
    //----
    Order_Select = OrderSelect(ticket, SELECT_BY_TICKET);
  
    //---- Calculation of the time interval between trading operations         
    ReCountLastTime(GetLastError());
    //----
    if (ticket > 0)
     {
     if (Order_Select)
        {
         //---- Blocking the dOpenSellOrder2_() function
                            // from repeated performance of the operation
         if(TimeLevel < 0)
                   SELL_Signal = false;
         //----
         if(TimeLevel > 0)
            GlobalVariableSet(GetTimeLevelName(Symb, MagicNumber), TimeLevel);
         //----
         OpderPrice = DoubleToStr(OrderOpenPrice(), Digits);  
         Print(StringConcatenate(Symb, " SELL order with ticket #",
                      ticket, " and magic number ", OrderMagicNumber(), 
                                                     " opened at the price ",OpderPrice));
         //----
         IfOrderModify[MagicNumber] = false;
        }
       else
        {
         Print(StringConcatenate("Failed to open ", Symb, 
                            " SELL order with the magic number ", MagicNumber, "!!!"));
         return(true);
        }
     }
    else
     {
       Print(StringConcatenate("Failed to open ", Symb, 
                         " SELL order with the magic number ", MagicNumber, "!!!"));
      return(true);
     }
   }
  
  //---+ Open order modification 
  if (!IfOrderModify[MagicNumber])
   {   
    
    if (STOPLOSS > 0) 
     {           
      if (STOPLOSS == 0 && TAKEPROFIT == 0)
       {
        IfOrderModify[MagicNumber] = true;
        return(true);
       }
      //----
      StLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
      if (StLOSS < 0)
          return(false);
      //----
      Stoploss = NormalizeDouble(OrderOpenPrice() + StLOSS * Point, Digits); 
      if (Stoploss < 0)
           return(false);
     }
    else 
     {
      if (STOPLOSS < 0)
           Print("dOpenSellOrder2_(): Invalid Stop Loss!!!");
      Stoploss = 0.0;
     } 
    //----   
    if (TAKEPROFIT > 0) 
     {           
      TkPROFIT = StopCorrect(Symb, TAKEPROFIT, Slippage_);
      if (TkPROFIT < 0)
          return(false);
      //----
      TakeProfit = NormalizeDouble(OrderOpenPrice() - TkPROFIT * Point, Digits);
      if (TakeProfit < 0)
               return(false);
     }
    else 
     {
      if (TAKEPROFIT < 0)
           Print("dOpenSellOrder2_(): Invalid Take Profit!!!");
      TakeProfit = 0.0;
     }
    //---- 
    Print(StringConcatenate
         ("Modify the ", Symb,
                       " SELL order with ticket #", OrderTicket(), 
                                             " with the magic number ", MagicNumber));       
    //----
    Order_Modify = OrderModify(OrderTicket(), 
                     OrderOpenPrice(), Stoploss, TakeProfit, 0, Blue);
                     
    //---- Calculation of the time interval between trading operations           
    CountLastTime(GetLastError());
    //----       
    if (Order_Modify)
     {
       Print(StringConcatenate(Symb, " SELL order with ticket #",
                                         OrderTicket(), " and the magic number ", 
                                             OrderMagicNumber(), " has been modified"));
       IfOrderModify[MagicNumber] = true;                                     
     }
    else Print(StringConcatenate("Failed to modify the SELL ", 
                            Symb, " order with ticket #", OrderTicket(), 
                                  " and the magic number ", OrderMagicNumber()));      
   }
   
  return(true);
//---+  
 }
//+X================================================================X+
//| CloseBuyOrder1_() function                                       |
//+X================================================================X+

bool CloseBuyOrder1_(bool& CloseStop, int MagicNumber)
  {
//----+
   if (!CloseStop)
          return(true);
   //---- Check if the minimum time interval has passed 
                                    //between two trading operations  
   if (TimeCurrent() < LastTime)
                          return(true); 
   //----                
   int total = OrdersTotal(); 
   if (total == 0)
            return(true);
   //----
   double priceClose;
   bool   Close_Order;
   color  Order_Color;
   //---- 
   int    FreezeLevelT, FreezeLevelS;
   int    ticket, DIGITS, FREEZELEVEL;
   string ClosePrice, Symb, Order_Type;
   
   //---- search for an open position with the required magic number 
   if (!OrderSelect_(Symbol(), OP_BUY, MagicNumber, MODE_TRADES))
                                                          return(true);
   //---- 
   ticket = OrderTicket(); 
   Symb = OrderSymbol();
   //---- 
   DIGITS = MarketInfo(OrderSymbol(), MODE_DIGITS); 
   if (DIGITS == 0)
             return(false);
                
   //----+ Getting values to delete the order
   priceClose = MarketInfo(Symb, MODE_BID);
   if (priceClose == 0)
                return(false);
   Order_Type =" BUY";
   Order_Color = Red;
 
   //----+ Check the order for freezing 
   FREEZELEVEL = MarketInfo(OrderSymbol(), MODE_FREEZELEVEL);
   FreezeLevelT = MathAbs(priceClose - OrderTakeProfit()) / Point;
   FreezeLevelS = MathAbs(priceClose - OrderStopLoss()) / Point;
   //----
   if (FreezeLevelT <= FREEZELEVEL
        || FreezeLevelS <= FREEZELEVEL)
                               return(true);
   
   //----+  Close the open position                                 
   Print(StringConcatenate("Close ",
                 Symb, Order_Type, " order with ticket #", ticket,
                                   " and the magic number ", MagicNumber));
   //---- 
   Close_Order = OrderClose(ticket, OrderLots(), priceClose, Slippage_, Order_Color);
   //---- Calculation of the time interval between trading operations         
   CountLastTime(GetLastError());
   //----                                        
   if(Close_Order)
     {
       CloseStop = false;
       ClosePrice = DoubleToStr(OrderClosePrice(), DIGITS);  
       Print(StringConcatenate(Symb, Order_Type, " order with ticket #",
                       ticket, " and magic number ", OrderMagicNumber(), 
                                             " closed at the price ", ClosePrice));
     }
   else Print(StringConcatenate("Failed to close the ", Symb, 
          Order_Type," order with ticket #", ticket, " and the magic number ", 
                                                         MagicNumber, "!!!"));
   //----   
   return(true);
//----+
  }  
//+X================================================================X+
//| CloseSellOrder1_() function                                      |
//+X================================================================X+

bool CloseSellOrder1_(bool& CloseStop, int MagicNumber)
  {
//----+
   if (!CloseStop)
          return(true);
   //---- Check if the minimum time interval has passed 
                                    //between two trading operations  
   if (TimeCurrent() < LastTime)
                          return(true); 
   //----                
   int total = OrdersTotal(); 
   if (total == 0)
            return(true);
   //----
   double priceClose;
   bool   Close_Order;
   color  Order_Color;
   //---- 
   int    FreezeLevelT, FreezeLevelS;
   int    ticket, DIGITS, FREEZELEVEL;
   string ClosePrice, Symb, Order_Type;
   
   //---- search for an open position with the required magic number 
   if (!OrderSelect_(Symbol(), OP_SELL, MagicNumber, MODE_TRADES))
                                                          return(true);
   //---- 
   ticket = OrderTicket(); 
   Symb = OrderSymbol();
   //---- 
   DIGITS = MarketInfo(OrderSymbol(), MODE_DIGITS); 
   if (DIGITS == 0)
             return(false);
                
   //----+ Getting values to delete the order
   priceClose = MarketInfo(Symb, MODE_ASK);
   if (priceClose == 0)
                return(false);
   Order_Type =" SELL";
   Order_Color = Lime;

   //----+ Check the order for freezing 
   FREEZELEVEL = MarketInfo(OrderSymbol(), MODE_FREEZELEVEL);
   FreezeLevelT = MathAbs(priceClose - OrderTakeProfit()) / Point;
   FreezeLevelS = MathAbs(priceClose - OrderStopLoss()) / Point;
   //----
   if (FreezeLevelT <= FREEZELEVEL
         || FreezeLevelS <= FREEZELEVEL)
                               return(true);
   
   //----+  Close the open position                                 
   Print(StringConcatenate("Close ",
                 Symb, Order_Type, " order with ticket #", ticket,
                                   " and the magic number ", MagicNumber));
   //---- 
   Close_Order = OrderClose(ticket, OrderLots(), priceClose, Slippage_, Order_Color);
   
   //---- Calculation of the time interval between trading operations         
   CountLastTime(GetLastError());
   //----                                        
   if(Close_Order)
     {
       CloseStop = false;
       ClosePrice = DoubleToStr(OrderClosePrice(), DIGITS);  
       Print(StringConcatenate(Symb, Order_Type, " order with ticket #",
                       ticket, " and magic number ", OrderMagicNumber(), 
                                             " closed at the price ", ClosePrice));
     }
   else Print(StringConcatenate("Failed to close the ", Symb, 
          Order_Type," order with ticket #", ticket, " and the magic number ", 
                                                         MagicNumber, "!!!"));
   //----   
   return(true);
//----+
  } 
//+X================================================================X+
//| dMake_BuyTrailingStop_() function                                |
//+X================================================================X+
bool dMake_BuyTrailingStop_
            (bool& TrailSignal, int MagicNumber, 
                 datetime TrailTimeLevel_, double dTRAILINGSTOP)
 {
//----+
  if(dTRAILINGSTOP <= 0 || !TrailSignal)
                                return(true);
  //---- Check if the minimum time interval has passed 
                                  //between two trading operations         
  if (TimeCurrent() < LastTime)
                          return(true); 
  //----
  string symb = Symbol();
  //----    
  if (OrdersTotal() == 0)
              return(true);  
              
  //---- Check if the time limit with respect to the previous trailing stop has expired
  if (!TrailTimeLevelCheck_(symb, MagicNumber, TrailTimeLevel_))
                                                     return(true);    
              
  //---- Check for a long open position 
        //with the magic number equal to the MagicNumber variable value          
  if (!OrderSelect_(symb, OP_BUY, MagicNumber, MODE_TRADES))
                                                      return(true);        
  //---- 
  bool Order_Modify;         
  color Order_Color;
  //----
  int ticket, digits, TRAILINGSTOP;
  int FREEZELEVEL, FreezeLevelT, FreezeLevelS; 
  //---- 
  double NewStopLoss, bid, point, TRStop, price;
  string NEWSTOPLOSS, Order_Type, PriceName;      
  //----
  symb = OrderSymbol();           
  ticket = OrderTicket(); 
  //----
  digits = MarketInfo(symb, MODE_DIGITS); 
  if (digits == 0)
            return(false);
  //----
  bid = NormalizeDouble(MarketInfo(symb, MODE_BID), digits); 
  if (bid == 0)
          return(false);
  //----
  point = MarketInfo(symb, MODE_POINT); 
  if (point == 0)
           return(false); 
  //----         
  TRAILINGSTOP = (bid - dTRAILINGSTOP) / point;  
  if (TRAILINGSTOP <= 0)
   {
    Print("dMake_BuyTrailingStop_(): Invalid Trailing Stop!!!");
    return(true);
   }     
  //----
  TRStop = StopCorrect(symb, TRAILINGSTOP, 0) * point;
  if (TRStop < 0)
           return(false);                                       

  //---+ Getting values for order modification
  if(bid - OrderStopLoss() > TRStop)
	{
	 price = bid;
	 NewStopLoss = NormalizeDouble(bid - TRStop, digits);
	 Order_Type =" BUY";
	 Order_Color = Lime;
	 PriceName = StringConcatenate(" BID = ", 
									DoubleToStr(bid, digits));
	}
  else return(true);
  
  //---- Check if the Stop Loss value is sufficient for modification
  if (NewStopLoss <= OrderStopLoss())
                             return(true);
  		
  //---+ Check the position for freezing 
  FREEZELEVEL = MarketInfo(OrderSymbol(), MODE_FREEZELEVEL);
  FreezeLevelT = MathAbs(price - OrderTakeProfit()) / point;
  FreezeLevelS = MathAbs(price - OrderStopLoss()) / point;
  //----
  if (FreezeLevelT <= FREEZELEVEL 
      || FreezeLevelS <= FREEZELEVEL)
							    	return(true);
										
  //---+ Modify the order 
  if(OrderCloseTime() != 0)
							return(true);
  Print(StringConcatenate("Move the Stop Loss using the Trailing Stop of ", 
            											TRAILINGSTOP, " points"));
  Print(StringConcatenate("Modify the Stop Loss. ",
                symb, Order_Type, " order with ticket #",ticket, 
											" and the magic number ", MagicNumber)); 
  //----
  Order_Modify = OrderModify(ticket, OrderOpenPrice(), NewStopLoss, 
       											OrderTakeProfit(), 0, Order_Color);
  //---- Calculation of the time interval between trading operations
  CountLastTime(GetLastError());
  //----                                   
  if(Order_Modify)
   {
    //---- Blocking the dMake_BuyTrailingStop_() function 
                                   // from repeated performance of the operation
    if(TrailTimeLevel_ < 0)
              TrailSignal = false;
    //----
    if(TrailTimeLevel_ > 0)
       GlobalVariableSet(GetTrailTimeLevelName_(symb, MagicNumber), TrailTimeLevel_);
    //----
    Print(StringConcatenate(symb, Order_Type, " order with ticket #", 
		ticket, " and the magic number ", OrderMagicNumber(), " has been modified"));
	//----              
	NEWSTOPLOSS = DoubleToStr(OrderStopLoss(), digits);  
	Print(StringConcatenate("New Stop Loss of the order ", 
							NEWSTOPLOSS, ". The calculated Stop Loss ", 
								DoubleToStr(NewStopLoss, digits), ".", PriceName)); 
   }
  else Print("Failed to modify ", symb, Order_Type, 
						" order with ticket #",ticket, " and the magic number ", 
																		OrderMagicNumber());
  //----    
  return(true);   
//----+
  } 
//+X================================================================X+
//| dMake_SellTrailingStop_() function                               |
//+X================================================================X+
bool dMake_SellTrailingStop_
            (bool& TrailSignal, int MagicNumber, 
                 datetime TrailTimeLevel_, double dTRAILINGSTOP)
 {
//----+
  if(dTRAILINGSTOP <= 0 || !TrailSignal)
                                return(true); 
  //---- Check if the minimum time interval has passed 
                                  //between two trading operations         
  if (TimeCurrent() < LastTime)
                          return(true); 
  //----
  string symb = Symbol();
  //----  
  if (OrdersTotal() == 0)
              return(true);
              
  //---- Check if the time limit with respect to the previous trailing stop has expired
  if (!TrailTimeLevelCheck_(symb, MagicNumber, TrailTimeLevel_))
                                                     return(true);
                                                     
  //---- Check for a short open position 
        //with the magic number equal to the MagicNumber variable value  
  if (!OrderSelect_(symb, OP_SELL, MagicNumber, MODE_TRADES))
                                                      return(true);            
  //---- 
  bool Order_Modify;          
  color Order_Color;
  //----
  int ticket, digits, TRAILINGSTOP;
  int FREEZELEVEL, FreezeLevelT, FreezeLevelS; 
  //---- 
  double NewStopLoss, ask, point, TRStop, price;
  string NEWSTOPLOSS, Order_Type, PriceName;      
  //----
  symb = OrderSymbol();          
  ticket = OrderTicket();
  //----
  digits = MarketInfo(symb, MODE_DIGITS); 
  if (digits == 0)
            return(false);
  //----
  ask = NormalizeDouble(MarketInfo(symb, MODE_ASK), digits); 
  if (ask == 0)
          return(false);
  //----
  point = MarketInfo(symb, MODE_POINT); 
  if (point == 0)
           return(false); 
  //----         
  TRAILINGSTOP = (dTRAILINGSTOP - ask) / point;  
  if (TRAILINGSTOP <= 0)
   {
    Print("dMake_SellTrailingStop_(): Invalid Trailing Stop!!!");
    return(true);
   }     
  //----
  TRStop = StopCorrect(symb, TRAILINGSTOP, 0) * point;
  if (TRStop < 0)
           return(false);

  //---+ Getting values for order modification
  if(OrderStopLoss() - ask > TRStop)
	{
	 price = ask;
	 NewStopLoss = NormalizeDouble(ask + TRStop, digits);
	 Order_Type =" SELL";
	 Order_Color = Red;
	 PriceName = StringConcatenate(" ASK = ", 
									DoubleToStr(ask, digits));
	}
  else return(true);
  
  //---- Check if the Stop Loss value is sufficient for modification
  if (NewStopLoss >= OrderStopLoss())
                             return(true);
  	
  //---+ Check the position for freezing 
  FREEZELEVEL = MarketInfo(OrderSymbol(), MODE_FREEZELEVEL);
  FreezeLevelT = MathAbs(price - OrderTakeProfit()) / point;
  FreezeLevelS = MathAbs(price - OrderStopLoss()) / point;
  //----
  if (FreezeLevelT <= FREEZELEVEL 
      || FreezeLevelS <= FREEZELEVEL)
							    	return(true);
										
  //---+ Modify the order 
  if(OrderCloseTime() != 0)
							return(true);
  Print(StringConcatenate("Move the Stop Loss using the Trailing Stop of ", 
            											TRAILINGSTOP, " points"));
  Print(StringConcatenate("Modify the Stop Loss. ",
						symb, Order_Type, " order with ticket #",ticket, 
											" and the magic number ", MagicNumber)); 
  //----
  Order_Modify = OrderModify(ticket, OrderOpenPrice(), NewStopLoss, 
       											OrderTakeProfit(), 0, Order_Color);
  //---- Calculation of the time interval between trading operations
  CountLastTime(GetLastError());
  //----                                   
  if(Order_Modify)
   {
    //---- Blocking the dMake_SellTrailingStop_() function 
                                   // from repeated performance of the operation
    if(TrailTimeLevel_ < 0)
              TrailSignal = false;
    //----
    if(TrailTimeLevel_ > 0)
       GlobalVariableSet(GetTrailTimeLevelName_(symb, MagicNumber), TrailTimeLevel_);
    //----
    Print(StringConcatenate(symb, Order_Type, " order with ticket #", 
		ticket, " and the magic number ", OrderMagicNumber(), " has been modified"));
	//----              
	NEWSTOPLOSS = DoubleToStr(OrderStopLoss(), digits);  
	Print(StringConcatenate("New Stop Loss of the order ", 
							NEWSTOPLOSS, ". The calculated Stop Loss ", 
								DoubleToStr(NewStopLoss, digits), ".", PriceName)); 
   }
  else Print("Failed to modify ", symb, Order_Type, 
						" order with ticket #",ticket, " and the magic number ", 
																		OrderMagicNumber());
  //----    
  return(true);   
//----+
  }
//+X================================================================X+
//| TimeLevelGlobalVariableDel() functions                           |
//+X================================================================X+
void TimeLevelGlobalVariableDel(string symbol, int MagicNumber)
  {
//---+
   if (IsTesting() || IsOptimization())
    {
     GlobalVariableDel(GetTimeLevelName       (symbol, MagicNumber));
     GlobalVariableDel(GetTrailTimeLevelName_ (symbol, MagicNumber));                       
    }
//---+ 
  }
//+X================================================================X+
//| TimeframeCheck() functions                                       |
//+X================================================================X+
void TimeframeCheck(string TimeframeName, int Timeframe)
  {
//---+
   //---- Check correctness of the Timeframe variable value
   if (Timeframe != 1)
    if (Timeframe != 5)
     if (Timeframe != 15)
      if (Timeframe != 30)
       if (Timeframe != 60)
        if (Timeframe != 240)
         if (Timeframe != 1440)
           Print(StringConcatenate("TimeframeCheck: The parameter ",
            TimeframeName, " cannot ", "be equal to ", Timeframe, "!!!"));    
//---+ 
  }

//+X================================================================X+
//| dGhartVelueCorrect() functions                                   |
//+X================================================================X+
double dGhartVelueCorrect(int cmd, double& GhartVelue)
  {
//---+
   switch(cmd)
    {
     case OP_BUY: GhartVelue += Ask - Close[0]; break;
     case OP_BUYLIMIT: GhartVelue += Ask - Close[0]; break;
     case OP_BUYSTOP: GhartVelue += Ask - Close[0]; break;
     //----
     case OP_SELL: GhartVelue -= Close[0] - Bid; break;
     case OP_SELLLIMIT: GhartVelue -= Close[0] - Bid; break;
     case OP_SELLSTOP: GhartVelue -= Close[0] - Bid; break;
     //----                                                                 
     default:  GhartVelue += 0.0;
    }
   return(GhartVelue); 
//---+ 
  }
//+X================================================================X+
//| OrderSelect_() functions                                         |
//+X================================================================X+
bool OrderSelect_(string symbol, int cmd, int MagicNumber, int pool)
  {
//---+
   //----                       
   int total;
   //----
   if (pool == MODE_TRADES)
         total = OrdersTotal();
   else 
    if (pool == MODE_HISTORY)           
         total = OrdersHistoryTotal();
  
   //---- Check for an open position 
          //with the magic number equal to the MagicNumber variable value
   for(int pos = total - 1; pos >= 0; pos--)     
      if (OrderSelect(pos, SELECT_BY_POS, pool))
       if (OrderType() == cmd)
        if (OrderSymbol() == symbol)
         if (OrderMagicNumber() == MagicNumber)
                                          return(true); 
   return(false); 
//---+ 
  }
//+X================================================================X+
//| Order_Select() functions                                         |
//+X================================================================X+
bool Order_Select(string symbol, int MagicNumber)
  {
//---+
   //----                       
   int total = OrdersTotal();
  
   //---- Check for an open position or order 
          //with the magic number equal to the MagicNumber variable value
   for(int pos = total - 1; pos >= 0; pos--)     
      if (OrderSelect(pos, SELECT_BY_POS, MODE_TRADES))
        if (OrderSymbol() == symbol)
         if (OrderMagicNumber() == MagicNumber)
                                          return(true); 
   return(false); 
//---+ 
  }
//+X================================================================X+
//| MarginCheck() function                                           |
//+X================================================================X+ 
bool MarginCheck(string symbol, int Cmd, double& Lot) 
 {
//---+
   int  Margin_Check;
   //---
   double MINLOT = MarketInfo(symbol, MODE_MINLOT);
   if (MINLOT == 0)
              return(false);
   //---          
   if (Lot < MINLOT)
    {
     Lot = 0.0;
     return(true);
    }
   //---           
   double LOTSTEP = MarketInfo(symbol, MODE_LOTSTEP);
   if (LOTSTEP == 0)
              return(false);
   //---           
   Lot = LOTSTEP * MathFloor(Lot / LOTSTEP); 
   //---
   while(Lot >= MINLOT && Margin_Check <= 0)
     {
       Margin_Check =
         AccountFreeMarginCheck(symbol, Cmd, Lot);
       //---              
       if (Margin_Check < 0)
                     Lot -= LOTSTEP; 
       //---              
       if (Lot < MINLOT)
        {
         Lot = 0.0;
         return(true);
        }
     }
            
  return(true);
//---+
 }
//+X================================================================X+
//| CountLastTime() function                                         |
//+X================================================================X+
void CountLastTime(int Error)
  {
//---+
   int TimeCurr = TimeCurrent();
   //---
   switch(Error)
       {
        case 000: LastTime = TimeCurr + 000; break;
        case 001: LastTime = TimeCurr + 060; break;
        case 002: LastTime = TimeCurr + 300; break;
        case 003: LastTime = TimeCurr + 300; break;                                                                  
        case 004: LastTime = TimeCurr + 180; break; 
        case 005: LastTime = TimeCurr + 000; break;
        case 006: LastTime = TimeCurr + 006; break;
        case 008: LastTime = TimeCurr + 011; break;
        case 064: LastTime = TimeCurr + 300; break;
        case 065: LastTime = TimeCurr + 180; break;                                                     
        case 128: LastTime = TimeCurr + 065; break; 
        case 129: LastTime = TimeCurr + 008; break; 
        case 130: LastTime = TimeCurr + 008; break;  
        case 131: LastTime = TimeCurr + 300; break;
        case 132: LastTime = TimeCurr + 180; break;
        case 133: LastTime = TimeCurr + 300; break;
        case 134: LastTime = TimeCurr + 008; break; 
        case 135: LastTime = TimeCurr + 000; break;
        case 136: LastTime = TimeCurr + 008; break; 
        case 138: LastTime = TimeCurr + 000; break;
        case 139: LastTime = TimeCurr + 011; break;
        case 140: LastTime = TimeCurr + 011; break; 
        case 141: LastTime = TimeCurr + 011; break;
        case 142: LastTime = TimeCurr + 065; break; 
        case 143: LastTime = TimeCurr + 065; break; 
        case 144: LastTime = TimeCurr + 011; break; 
        case 145: LastTime = TimeCurr + 017; break;  
        case 146: LastTime = TimeCurr + 300; break;
        case 147: LastTime = TimeCurr + 011; break;
        case 148: LastTime = TimeCurr + 300; break;
        default:  LastTime = TimeCurr + 000; break;
       }
//---+
  }
//+X================================================================X+
//| ReCountLastTime() function                                       |
//+X================================================================X+
void ReCountLastTime(int Error)
  {
//---+
   //---
   switch(Error)
       {
        case 000: LastTime += 000; break;
        case 001: LastTime += 060; break;
        case 002: LastTime += 300; break;
        case 003: LastTime += 300; break;                                                                  
        case 004: LastTime += 180; break; 
        case 005: LastTime += 000; break;
        case 006: LastTime += 006; break;
        case 008: LastTime += 011; break;
        case 064: LastTime += 300; break;
        case 065: LastTime += 180; break;                                                     
        case 128: LastTime += 065; break; 
        case 129: LastTime += 007; break; 
        case 130: LastTime += 007; break;  
        case 131: LastTime += 300; break;
        case 132: LastTime += 180; break;
        case 133: LastTime += 300; break;
        case 134: LastTime += 007; break; 
        case 135: LastTime += 000; break;
        case 136: LastTime += 007; break; 
        case 138: LastTime += 000; break;
        case 139: LastTime += 011; break;
        case 140: LastTime += 011; break; 
        case 141: LastTime += 011; break;
        case 142: LastTime += 065; break; 
        case 143: LastTime += 065; break; 
        case 144: LastTime += 011; break; 
        case 145: LastTime += 017; break;  
        case 146: LastTime += 300; break;
        case 147: LastTime += 011; break;
        case 148: LastTime += 300; break;
        default:  LastTime += 000; break;
       }
//---+
  }
//+X================================================================X+
//| GetFreeMargin() function                                         |
//+X================================================================X+
double GetFreeMargin()
  {
//---+
   switch(AccountFreeMarginMode())
    {     
     case 0: return(AccountFreeMargin() + AccountProfit());
     case 1: return(AccountFreeMargin());
     case 2: if (AccountProfit() > 0) 
                  return(AccountFreeMargin());
             else return(AccountFreeMargin() - AccountProfit());
     case 3: if (AccountProfit() < 0) 
                  return(AccountFreeMargin());
             else return(AccountFreeMargin() - AccountProfit());
    }
//---+
  } 
//+X================================================================X+
//| StopCorrect() function                                           |
//+X================================================================X+
int StopCorrect(string symbol, int Stop, int slippage_)
  {
//---+
   int CorrStop, Extrem_Stop;
   //---
   Extrem_Stop = MarketInfo(symbol, MODE_STOPLEVEL) + slippage_;
   //---             
   if(Stop < Extrem_Stop)
        CorrStop = Extrem_Stop;
   else CorrStop = Stop;
   //---   
   return(CorrStop);
//---+
  }
//+X================================================================X+
//| GetTimeLevelName() function                                      |
//+X================================================================X+
string GetTimeLevelName(string symbol, int MagicNumber)
  {
//---+
   string G_Name_;
   static string G_Name_0;
   static bool SecondStart;
   //---- Initialization to zero
   if (!SecondStart)
    {
     G_Name_0 = StringConcatenate
             ("TimeLevel", "_", AccountNumber(), "_");
     //----  
     if (IsTesting() || IsOptimization())
          G_Name_0 = StringConcatenate(G_Name_0, "_Test_");
     //----              
     SecondStart = true;
    }
   //----
   G_Name_ = StringConcatenate(G_Name_0, symbol, "_", MagicNumber);   
   //----   
   return(G_Name_);
//---+
  }
//+X================================================================X+
//| GetTrailTimeLevelName_() function                                |
//+X================================================================X+
string GetTrailTimeLevelName_(string symbol, int MagicNumber)
  {
//---+
   string G_Name_;
   static string G_Name_0;
   static bool SecondStart;
   //---- Initialization to zero
   if (!SecondStart)
    {
     G_Name_0 = StringConcatenate
             ("TrailTimeLevel_", "_", AccountNumber(), "_");
     //----  
     if (IsTesting() || IsOptimization())
          G_Name_0 = StringConcatenate(G_Name_0, "_Test_");
     //----              
     SecondStart = true;
    }
   //----
   G_Name_ = StringConcatenate(G_Name_0, symbol, "_", MagicNumber);   
   //----   
   return(G_Name_);
//---+
  }
//+X================================================================X+
//| TradeTimeLevelCheck() function                                   |
//+X================================================================X+
bool TradeTimeLevelCheck
             (string symbol, int MagicNumber, datetime TradeTimeLevel)
  {
//---+
   //----
  if (TradeTimeLevel > 0)
   {
    //---- Getting the name of a global 
          //variable for storing the time limit
    string G_Name_ = GetTimeLevelName(symbol, MagicNumber);
  
    //---- Check if the time limit with respect to the previous deal has expired 
    if (TimeCurrent() < GlobalVariableGet(G_Name_))
                                            return(false); 
    } 
   return(true);
//---+
  }
//+X================================================================X+
//| TrailTimeLevelCheck_() function                                  |
//+X================================================================X+
bool TrailTimeLevelCheck_
            (string symbol, int MagicNumber, datetime TrailTimeLevel_)
  {
//---+
   //----
  if (TrailTimeLevel_ > 0)
   {
    //---- Getting the name of a global 
          //variable for storing the time limit
    string G_Name_ = GetTrailTimeLevelName_(symbol, MagicNumber);
  
    //---- Check if the time limit with respect to the previous deal has expired 
    if (TimeCurrent() < GlobalVariableGet(G_Name_))
                                            return(false); 
    } 
   return(true);
//---+
  }
//+X================================================================X+
//| BuyLotCount_() function                                          |  
//+X================================================================X+
/*                                                                   |
 The Margin_Mode external variable determines the lot size | 
 calculation                                                                |
 0 - MM based on free margin                              |
 1 - MM based on the account balance                                  |
 2 - MM based on losses on free margin                     |
 3 - MM based on losses on the account balance                       |
 by default - MM based on free margin                   |
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
 if Money_Management is negative, the trading function uses | 
 the absolute Money_Management value rounded to the nearest standard value |
 as the lot size.                      |
*/                                                                // |
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
double BuyLotCount_
           (double Money_Management, int Margin_Mode, int STOPLOSS)
  {
//---+
  string Symb = Symbol(); 
  int    StLOSS;
  double LOTSTEP, MINLOT, MAXLOT, MARGINREQUIRED, TICKVALUE;
  double FreeMargin, LotVel, Lot;                                             

  //---1+ LOT SIZE CALCULATION FOR OPENING A POSITION
  if (Money_Management < 0)
       LotVel = MathAbs(Money_Management);
  else      
   switch(Margin_Mode)
    {
     //---+ Lot calculations based on free margin
     case  0:       
      MARGINREQUIRED = MarketInfo(Symb, MODE_MARGINREQUIRED);
      if (MARGINREQUIRED == 0.0)     
                           return(-1);             
      //----              
      LotVel = GetFreeMargin()
                * Money_Management / MARGINREQUIRED;               
      break;
  
    //---+ Lot calculation based on the account balance
    case  1:     
     MARGINREQUIRED = MarketInfo(Symb, MODE_MARGINREQUIRED);
     if (MARGINREQUIRED == 0.0)    
                       return(-1);          
     //----                
     LotVel = AccountBalance()
                  * Money_Management / MARGINREQUIRED;            
     break;
  
    //---+ Lot calculation based on losses on free margin             
    case  2:
     if (STOPLOSS <= 0)
      {
       Print("BuyLotCount(): Invalid Stop Loss!!!");
       STOPLOSS = 0;
      }
     //---- 
     StLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
     if (StLOSS <= 0)     
                return(-1);
     //----
     TICKVALUE = MarketInfo(Symb, MODE_TICKVALUE);
     if (TICKVALUE == 0.0)  
                   return(-1);            
     //----               
     LotVel = GetFreeMargin() *  MathAbs(Money_Management)
                                     / (TICKVALUE * StLOSS);
     break;
   
    //---+ Lot calculation based on losses on the account balance
    case  3:
     if (STOPLOSS <= 0)
      {
       Print("BuyLotCount(): Invalid Stop Loss!!!");
       STOPLOSS = 0;
      }
     //---- 
     StLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
     if (StLOSS <= 0)    
              return(-1);
     //----
     TICKVALUE = MarketInfo(Symb, MODE_TICKVALUE);
     if (TICKVALUE == 0.0)     
                    return(-1);            
     //----               
     LotVel = AccountBalance()
                *  MathAbs(Money_Management) 
                               / (TICKVALUE * StLOSS);
     break;
  
    //---+ Lot calculation based on free margin by default
    default:      
     MARGINREQUIRED = MarketInfo(Symb, MODE_MARGINREQUIRED);
     if (MARGINREQUIRED == 0.0)    
                        return(-1);              
     //----               
     LotVel = GetFreeMargin()
               * Money_Management / MARGINREQUIRED;         
    }
   //---1+   
   
  LOTSTEP = MarketInfo(Symb, MODE_LOTSTEP);
  if (LOTSTEP <= 0)    
           return(-1);
           
  //---- lot size normalization to the nearest standard value 
  Lot = LOTSTEP * MathFloor(LotVel / LOTSTEP);  
  
  //---+ check the lot for the minimum allowable value
  MINLOT = MarketInfo(Symb, MODE_MINLOT);
  if (MINLOT < 0)    
           return(-1);
  //----        
  if (Lot < MINLOT)  
            return(0);        
          
  //---+ check the lot for the maximum allowable value
  MAXLOT = MarketInfo(Symb, MODE_MAXLOT);
  if (MAXLOT < 0)    
           return(-1);         
  //----
  if (Lot > MAXLOT)
          Lot = MAXLOT;
  //----              
  return(Lot);        
//---+
  }   
//+X================================================================X+
//| SellLotCount_() function                                         |
//+X================================================================X+
/*                                                                   |
 The Margin_Mode external variable determines the lot size | 
 calculation                                                                |
 0 - MM based on free margin                              |
 1 - MM based on the account balance                                  |
 2 - MM based on losses on free margin                     |
 3 - MM based on losses on the account balance                       |
 by default - MM based on free margin                   |
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
 if Money_Management is negative, the trading function uses | 
 the absolute Money_Management value rounded to the nearest standard value |
 as the lot size.                      |
*/                                                                // |
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
double SellLotCount_
            (double Money_Management, int Margin_Mode, int STOPLOSS)
  {
//---+
  string Symb = Symbol(); 
  int    SPREAD, StLOSS;
  double LOTSTEP, MINLOT, MAXLOT, MARGINREQUIRED;
  double LotVel, Lot, TICKVALUE, TICKSIZE;                                               
  
  //---1+ LOT SIZE CALCULATION FOR OPENING A POSITION
  if (Money_Management < 0)
       LotVel = MathAbs(Money_Management);
  else      
   switch(Margin_Mode)
    {
     //---+ Lot calculations based on free margin
     case  0:     
      MARGINREQUIRED = MarketInfo(Symb, MODE_MARGINREQUIRED);
      if (MARGINREQUIRED == 0.0)    
                           return(-1);           
      //---
      SPREAD = MarketInfo(Symb, MODE_SPREAD);
      //---
      TICKVALUE = MarketInfo(Symb, MODE_TICKVALUE);
      //---
      LotVel = GetFreeMargin() * Money_Management / 
                   (MARGINREQUIRED - (SPREAD * TICKVALUE));                  
      break;
  
    //---+ Lot calculation based on the account balance
    case  1:      
     MARGINREQUIRED = MarketInfo(Symb, MODE_MARGINREQUIRED);
     if (MARGINREQUIRED == 0.0)    
                        return(-1);          
     //---
     SPREAD = MarketInfo(Symb, MODE_SPREAD);
     //---
     TICKVALUE = MarketInfo(Symb, MODE_TICKVALUE);
     //---
     LotVel = AccountBalance() * Money_Management / 
                   (MARGINREQUIRED - (SPREAD * TICKVALUE));                  
     break;
 
    //---+ Lot calculation based on losses on free margin
    case  2:
     if (STOPLOSS <= 0)
      {
       Print("SellLotCount(): Invalid Stop Loss!!!");
       STOPLOSS = 0;
      }
     //---- 
     StLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
     if (StLOSS <= 0)    
                return(-1);
     //----  
     TICKVALUE = MarketInfo(Symb, MODE_TICKVALUE);
     if (TICKVALUE == 0.0)   
                    return(-1);          
     //---
     SPREAD = MarketInfo(Symb, MODE_SPREAD);
     //---              
     LotVel = GetFreeMargin()
                * MathAbs(Money_Management) 
                      / (TICKVALUE * (StLOSS + SPREAD));
     break;
   
    //---+ Lot calculation based on losses on the account balance  
    case  3:
     if (STOPLOSS <= 0)
      {
       Print("SellLotCount(): Invalid Stop Loss!!!");
       STOPLOSS = 0;
      }
     //---- 
     StLOSS = StopCorrect(Symb, STOPLOSS, Slippage_);
     if (StLOSS <= 0)    
               return(-1);
     //----  
     TICKVALUE = MarketInfo(Symb, MODE_TICKVALUE);
     if (TICKVALUE == 0.0)   
                    return(-1);            
     //---
     SPREAD = MarketInfo(Symb, MODE_SPREAD);
     //---              
     LotVel = AccountBalance()
               * MathAbs(Money_Management) 
                      / (TICKVALUE * (StLOSS + SPREAD));
     break;                                                                                
   
    //---+ Lot calculation based on free margin by default
    default:        
     MARGINREQUIRED = MarketInfo(Symb, MODE_MARGINREQUIRED);
     if (MARGINREQUIRED == 0.0)     
                        return(-1);             
     //---
     SPREAD = MarketInfo(Symb, MODE_SPREAD);
     //---
     TICKVALUE = MarketInfo(Symb, MODE_TICKVALUE);
     //---
     LotVel = GetFreeMargin() * Money_Management / 
                  (MARGINREQUIRED - (SPREAD * TICKVALUE));                   
    }
   
  //----  
  LOTSTEP = MarketInfo(Symb, MODE_LOTSTEP); 
  if (LOTSTEP <= 0)    
           return(-1);
             
  //---- lot size normalization to the nearest standard value   
  Lot = LOTSTEP * MathFloor(LotVel / LOTSTEP);
  
  //---+ check the lot for the minimum allowable value
  MINLOT = MarketInfo(Symb, MODE_MINLOT);
  if (MINLOT < 0)    
           return(-1);            
   
  if (Lot < MINLOT)   
            return(0);           
          
  //---+ check the lot for the maximum allowable value
  MAXLOT = MarketInfo(Symb, MODE_MAXLOT);
  if (MAXLOT < 0)    
        return(-1);           
   
  if (Lot > MAXLOT)
          Lot = MAXLOT;
  //----       
  return(Lot);
//---+
  }
//+X================================================================X+
//| BuyLotCount() function                                           |  
//+X================================================================X+
/*                                                                   |
 The Margin_Mode external variable determines the lot size | 
 calculation                                                                |
 0 - MM based on free margin                              |
 1 - MM based on the account balance                                  |
 2 - MM based on losses on free margin                     |
 3 - MM based on losses on the account balance                       |
 4 - minimum lot between 0 and 2                                     |
 5 - minimum lot between 1 and 3                                     |
 by default - MM based on free margin                   |
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
 if Money_Management is negative, the trading function uses | 
 the absolute Money_Management value rounded to the nearest standard value |
 as the lot size.                      |
*/                                                                // |
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
double BuyLotCount
      (double Money_Management, int Margin_Mode, int STOPLOSS)
  {
//---+
   if (Money_Management < 0)
                 return(BuyLotCount_(Money_Management, 0, 0));
   //----
   double LotA, LotB;
   int MarModeA, MarModeB;
   //----
   switch(Margin_Mode)
    {
     case 4: 
      MarModeA = 0;
      MarModeB = 2;
      break;      
      //----
     case 5:
      MarModeA = 1;
      MarModeB = 3;
      break;
      //----                                                                 
     default: return(BuyLotCount_(Money_Management, 
                                      Margin_Mode, STOPLOSS));
    }
    
    LotA = BuyLotCount_(Money_Management, MarModeA, STOPLOSS);
    if (LotA == -1)
              return(-1);
    //----          
    LotB = BuyLotCount_(Money_Management, MarModeB, STOPLOSS);
    if (LotB == -1)
              return(-1);
   //----              
   if (LotA < LotB)
        return(LotA);
   else return(LotB);         
//---+
  }
//+X================================================================X+
//| SellLotCount() function                                          |  
//+X================================================================X+   
/*                                                                   |
 The Margin_Mode external variable determines the lot size | 
 calculation                                                                |
 0 - MM based on free margin                              |
 1 - MM based on the account balance                                  |
 2 - MM based on losses on free margin                     |
 3 - MM based on losses on the account balance                       |
 4 - minimum lot between 0 and 2                                     |
 5 - minimum lot between 1 and 3                                     |
 by default - MM based on free margin                   |
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
 if Money_Management is negative, the trading function uses | 
 the absolute Money_Management value rounded to the nearest standard value |
 as the lot size.                      |
*/                                                                // |
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
double SellLotCount
      (double Money_Management, int Margin_Mode, int STOPLOSS)
  {
//---+
   if (Money_Management < 0)
                return(SellLotCount_(Money_Management, 0, 0));
   //----
   double LotA, LotB;
   int MarModeA, MarModeB;
   //----
   switch(Margin_Mode)
    {
     case 4: 
      MarModeA = 0;
      MarModeB = 2;
      break;      
      //----
     case 5:
      MarModeA = 1;
      MarModeB = 3;
      break;
      //----                                                                 
     default: return(SellLotCount_(Money_Management, 
                                       Margin_Mode, STOPLOSS));
    }
    
    LotA = SellLotCount_(Money_Management, MarModeA, STOPLOSS);
    if (LotA == -1)
              return(-1);
    //----          
    LotB = SellLotCount_(Money_Management, MarModeB, STOPLOSS);
    if (LotB == -1)
              return(-1);
   //----              
   if (LotA < LotB)
        return(LotA);
   else return(LotB);         
//---+
  }
//+X================================================================X+
//| IndicatorCounted_() function                                     |  
//+X================================================================X+
// Analog of the IndicatorCounted() function that operates in EAs
int IndicatorCounted_(int Number, string symbol, int timeframe)
  {
//---+
   static int OldBars[1];
   static datetime BarTime[1];
   //----
   datetime _iTime;
   int Resalt, Bars_, size = Number + 1; 
   
   //---- Get the initial values
   Bars_ = iBars(symbol, timeframe) - 1;
   _iTime = iTime(symbol, timeframe, Bars_);
   
   //---- Check for errors
   if (Bars_ <= 0 || _iTime == 0)
                           return(-1);
   
   //---- Allocation of memory for arrays
   if (ArraySize(OldBars) < size)
    {
     if (ArrayResize(OldBars, size) < size)
      {
       Print(StringConcatenate
           ("IndicatorCounted_(Number = ", Number, 
            "): Failed to resize the OldBars buffer!!!"));
       //----    
       return(-1);
      }
     if (ArrayResize(BarTime, size) < size)
      {
       Print(StringConcatenate
           ("IndicatorCounted_(Number = ", Number, 
            "): Failed to resize the BarTime buffer!!!"));
       //----    
       return(-1);
      }
    }
    
   //---- Check if the history loads
   if (BarTime[Number] != _iTime)
    {
     OldBars[Number] = Bars_;
     BarTime[Number] = _iTime;
     return(0);
    }
   //----
   Resalt = OldBars[Number];
   
   //---- Check for the bar change
   if (Bars_ != OldBars[Number])
    {
     OldBars[Number] = Bars_;
    }
   //----
   return(Resalt);         
//---+
  }
//+X================================================================X+
//| ReSetAsIndexBuffer() function                                    |  
//+X================================================================X+
int ReSetAsIndexBuffer(string symbol, int timeframe, double& array[])
  {
//---+
   int IBars = iBars(symbol, timeframe);
   //----
   if (IBars <= 0)
           return(-1);

   //---- INDICATOR BUFFER EMULATION
   if (ArrayRange(array, 0) < IBars)
    {
     ArraySetAsSeries(array, false);
     //----
     if (ArrayResize(array, IBars) < IBars)
      {
       Print("ReSetAsIndexBuffer(): Failed to resize the buffer!!!");
       //----    
       return(-1);
      }
     //---- 
     ArraySetAsSeries(array, true);
    } 
//---- 
   //----
   return(IBars);         
//---+
  }
//+X================================================================X+
//| IsNewBar() function                                              |  
//+X================================================================X+
bool IsNewBar(int Number, string symbol, int timeframe)
  {
//---+
   datetime Time2_;
   int Size = Number + 1;
   static datetime Time2[];  

   //---- Allocation of memory for the Time2[] array
   if (ArrayRange(Time2, 0) < Size)
     if (ArrayResize(Time2, Size) < Size)
      {
       Print("IsNewBar(): Failed to resize the Time2[] buffer!!!");
       PlaySound("alert.wav");    
       return(false);
      }
   //----
   Time2_ = iTime(symbol, timeframe, 2);
   if (Time2_ == 0)
           return(false);
   
   //---- Check for a new bar       
   if (Time2_ != Time2[Number])
    {
     Time2[Number] = Time2_; 
     return(true);
    } 
   //----
   return(false);         
//---+
  } 
//+X================================================================X+
//| MinBarCheck() function                                           |  
//+X================================================================X+
bool MinBarCheck(string symbol, int timeframe, int MinBarTotal)
  {
//---+
   if (iBars(symbol, timeframe) < MinBarTotal)
                                      return(false); 
   //----
   return(true);         
//---+
  }                                                                                              
//+X================================================================X+
//| Custom Expert initialization function                            |
//+X================================================================X+
int init()
  {
//---- Checking correctness of the Timeframe_Up variable value
   TimeframeCheck("Timeframe_Up", Timeframe_Up);
//---- Checking correctness of the Timeframe_Dn variable value 
   TimeframeCheck("Timeframe_Dn", Timeframe_Dn);
//---- Setting alerts for invalid values of external variables
   JJMASeries1Alert (0, "Length_Up", Length_Up);
   JJMASeries1Alert (1, "Phase_Up", Phase_Up);
//---- Setting alerts for invalid values of external variables  
   JJMASeries1Alert (0, "Length_Dn", Length_Dn);
   JJMASeries1Alert (1, "Phase_Dn", Phase_Dn);
//---- Setting alerts for invalid values of external variables   
   iPriceSeriesAlert(IPC_Up);
   iPriceSeriesAlert(IPC_Dn);
//---- Initialization of variables             
   MinBar_Up = 4 + 39 + 30;// four bars for 
                   //entry signals + FATL filter length + JMA filter length
   MinBar_Up = MathMax(MinBar_Up, ATR_Period_Up + 1);                 
   MinBar_Dn = 4 + 39 + 30;// four bars for 
                   //entry signals + FATL filter length + JMA filter length
   MinBar_Dn = MathMax(MinBar_Dn, ATR_Period_Dn + 1); 
//----  
   Period_Up = Timeframe_Up * 60; // chart time frame for long positions in seconds 
   Period_Dn = Timeframe_Dn * 60; // chart time frame for short positions in seconds 
   
//---- Conversion of percent to fraction
   _STOPLOSS_Up = STOPLOSS_Up / 100.0;
   _TAKEPROFIT_Up = TAKEPROFIT_Up / 100.0;
   _TRAILINGSTOP_Up = TRAILINGSTOP_Up / 100.0;
//---- Conversion of percent to fraction
   _STOPLOSS_Dn = STOPLOSS_Dn / 100.0;
   _TAKEPROFIT_Dn = TAKEPROFIT_Dn / 100.0;
   _TRAILINGSTOP_Dn = TRAILINGSTOP_Dn / 100.0;
//---- Conversion of the minimum points to the price distance minimum
   _LevMinimum_Up = LevMinimum_Up * Point;
   _LevMinimum_Dn = LevMinimum_Dn * Point; 
   //---- Allocation of memory for static variables of the JFATL() function
      // Two calls of the JFATL() function in the code of the Expert Advisor
   if (!JFATLResize(2))
    {
     INIT = false;
     return(-1);
    }                             
//---- initialization complete
   INIT = true; 
   return(0);
  }
//+X================================================================X+
//| expert deinitialization function                                 |
//+X================================================================X+  
int deinit()
  {
//----+
   //----+ Deleting global variables 
                           //after testing and optimizations
   TimeLevelGlobalVariableDel(Symbol(), 1);
   TimeLevelGlobalVariableDel(Symbol(), 2);
   //---- Expert Advisor deinitialization complete
   return(0);
//----+ 
  }
//+X================================================================X+
//| Custom Expert iteration function                                 |
//+X================================================================X+
int start()
  {
//----+
   //---- checking if the initialization is complete
   if (!INIT)
			return(-1); 
   //----+ Declaration of local variables
   double dMov12, dMov23, ATR, Level, open;
   //----+ Declaration of static variables
   static datetime TradeTimeLevel_Up, TradeTimeLevel_Dn;
   //----
   static bool BUY_Sign, BUY_Stop, SELL_Sign, SELL_Stop;
   static bool TrailSignal_Up, TrailSignal_Dn;
   //----
   static double Mov_Up[], Mov_Dn[];
   static double dStopLoss_Up, dTakeProfit_Up, dTrailingStop_Up;
   static double dStopLoss_Dn, dTakeProfit_Dn, dTrailingStop_Dn;
     
   //+---------------------------+
   //| CODE FOR LONG POSITIONS   |
   //+---------------------------+
   if (Test_Up) 
      if (MinBarCheck(Symbol(), Timeframe_Up, MinBar_Up))
       {
         if (IsNewBar(0, Symbol(), Timeframe_Up))
          {
           //----+ Zeroing out trading signals 
           BUY_Sign = false;
           BUY_Stop = false;
           //---- Getting the time limit for disabling 
                                         // the next trading operation
           TradeTimeLevel_Up = iTime(NULL, Timeframe_Up, 0);
           if (TradeTimeLevel_Up == 0)
            return(-1);
           TradeTimeLevel_Up += Period_Up;
                      
           //----+ CALCULATING AND LOADING INDICATOR VALUES TO BUFFERS
           if (!JFATL(0, Symbol(), Timeframe_Up,
                       Length_Up, Phase_Up, IPC_Up, Mov_Up))
                                                      return(-1);
                                                      
           //----+ DETERMINING SIGNALS FOR DEALS 
           dMov12 = Mov_Up[1] - Mov_Up[2];
           dMov23 = Mov_Up[2] - Mov_Up[3]; 
           //---- Getting a signal for opening a position                               
           if (dMov23 < 0)
              if (dMov12 > 0)
                        BUY_Sign = true;
           //---- Getting a signal for closing a position             
           if (dMov12 < 0)
              if (ClosePos_Up)
                        BUY_Stop = true; 
                        
           //----+ CALCULATION OF PENDING ORDERS FOR LONG POSITIONS
           // Make order calculation only if the trading signal is available
           if (BUY_Sign)
            {
             //---- Getting the initial ATR value                                    
             ATR = iATR(NULL, Timeframe_Up, ATR_Period_Up, 1);
             //---- Getting the current price
             open = iOpen(Symbol(), Timeframe_Up, 0);
             
             //---- Calculating the distance to the Stop Loss
             Level = ATR * _STOPLOSS_Up;
             //---- Checking the distance to the Stop Loss against the minimum value
             if (Level < _LevMinimum_Up)
                     Level = _LevMinimum_Up;
             //---- Determining the absolute Stop Loss value
             dStopLoss_Up = open - Level;
             
             //---- Calculating the distance to the Take Profit
             Level = ATR * _TAKEPROFIT_Up;
             //---- Checking the distance to the Take Profit against the minimum value
             if (Level < _LevMinimum_Up)
                     Level = _LevMinimum_Up;
             //---- Determining the absolute Take Profit value      
             dTakeProfit_Up = open + Level; 
             
             //---- Correcting values of pending
                           // orders, given the direction of the trade
             dGhartVelueCorrect(OP_BUY, dStopLoss_Up);
             dGhartVelueCorrect(OP_BUY, dTakeProfit_Up);  
            } 
            
           //----+ CALCULATION OF TRAILING STOPS FOR LONG POSITIONS
           dTrailingStop_Up = 0;  
           TrailSignal_Up = false;
           //----
           if (TRAILINGSTOP_Up > 0)
            // Calculate the Trailing Stop only if the necessary position exists
            if (OrderSelect_(Symbol(), OP_BUY, 1, MODE_TRADES))
             // Move Trailing Stop if the position is opened on a non-zero bar
             if (iBarShift(NULL, Timeframe_Up, OrderOpenTime(), false) > 0)
              {
               TrailSignal_Up = true;
               //---- Getting the initial ATR value 
               ATR = iATR(NULL, Timeframe_Up, ATR_Period_Up, 1);
               //---- Getting the current price
               open = iOpen(Symbol(), Timeframe_Up, 0);
               //---- Calculating the distance to the Stop Loss
               Level = ATR * _TRAILINGSTOP_Up;
               //---- Checking the distance to the Stop Loss against the minimum value
               if (Level < _LevMinimum_Up)
                        Level = _LevMinimum_Up;
               //---- Getting the absolute Trailing Stop value          
               dTrailingStop_Up = open - Level;
               //---- Correcting the absolute Trailing Stop value, 
                        // given the direction of the trade (for position 
                           // modification functions the value of the cmd variable is inverse!)
               dGhartVelueCorrect(OP_SELL, dTrailingStop_Up);
              }                                     
          }
         
         //----+ DEAL EXECUTION
         if (!CloseBuyOrder1_(BUY_Stop, 1))
                                      return(-1);                       
         //----                                 
         if (!dOpenBuyOrder1_(BUY_Sign, 1, TradeTimeLevel_Up,
               Money_Management_Up, 5, dStopLoss_Up, dTakeProfit_Up))
                                                             return(-1);
         //----
         if (!dMake_BuyTrailingStop_(TrailSignal_Up, 1, 
                          TradeTimeLevel_Up, dTrailingStop_Up))
                                                       return(-1);
       }
   //+---------------------------+
   //| CODE FOR SHORT POSITIONS  |
   //+---------------------------+
   if (Test_Dn) 
      if (MinBarCheck(Symbol(), Timeframe_Dn, MinBar_Dn))
       {
         if (IsNewBar(1, Symbol(), Timeframe_Dn))
          {
           //----+ Zeroing out trading signals
           SELL_Sign = false;
           SELL_Stop = false;
           //---- Getting the time limit for disabling 
                                         // the next trading operation
           TradeTimeLevel_Dn = iTime(NULL, Timeframe_Dn, 0);
           if (TradeTimeLevel_Dn == 0)
            return(-1);
           TradeTimeLevel_Dn += Period_Dn;
                                        
           //----+ CALCULATING AND LOADING INDICATOR VALUES TO BUFFERS
           if (!JFATL(1, Symbol(), Timeframe_Dn,
                       Length_Dn, Phase_Dn, IPC_Dn, Mov_Dn))
                                                      return(-1);
                                                      
           //----+ DETERMINING SIGNALS FOR DEALS 
           dMov12 = Mov_Dn[1] - Mov_Dn[2];
           dMov23 = Mov_Dn[2] - Mov_Dn[3];
           //---- Getting a signal for opening a position                               
           if (dMov23 > 0)
              if (dMov12 < 0)
                       SELL_Sign = true;
           //---- Getting a signal for closing a position              
           if (dMov12 > 0)
               if (ClosePos_Dn)
                       SELL_Stop = true;
                       
           //----+ CALCULATION OF PENDING ORDERS FOR SHORT POSITIONS
           // Make order calculation only if the trading signal is available
           if (SELL_Sign)
            {                                   
             //---- Getting the initial ATR value
             ATR = iATR(NULL, Timeframe_Dn, ATR_Period_Dn, 1);
             //---- Getting the current price
             open = iOpen(Symbol(), Timeframe_Dn, 0);
             
             //---- Calculating the distance to the Stop Loss
             Level = ATR * _STOPLOSS_Dn;
             //---- Checking the distance to the Stop Loss against the minimum value
             if (Level < _LevMinimum_Dn)
                     Level = _LevMinimum_Dn;
             //---- Determining the absolute Stop Loss value
             dStopLoss_Dn = open + Level;
           
             //---- Calculating the distance to the Take Profit
             Level = ATR * _TAKEPROFIT_Dn;
             //---- Checking the distance to the Take Profit against the minimum value
             if (Level < _LevMinimum_Dn)
                     Level = _LevMinimum_Dn;
             //---- Determining the absolute Take Profit value          
             dTakeProfit_Dn = open - Level;   
             
             //---- Correcting values of pending
                         // orders, given the direction of the trade
             dGhartVelueCorrect(OP_SELL, dStopLoss_Dn);     
             dGhartVelueCorrect(OP_SELL, dTakeProfit_Dn);
            }
           
           //----+ CALCULATION OF TRAILING STOPS FOR SHORT POSITIONS
           dTrailingStop_Dn = 0;
           TrailSignal_Dn = false;
           //----
           if (TRAILINGSTOP_Dn > 0)
            // Calculate the Trailing Stop only if the necessary position exists
            if (OrderSelect_(Symbol(), OP_SELL, 2, MODE_TRADES))
             // Move Trailing Stop if the position is opened on a non-zero bar
             if (iBarShift(NULL, Timeframe_Dn, OrderOpenTime(), false) > 0) 
              {
               TrailSignal_Dn = true;
               //---- Getting the initial ATR value 
               ATR = iATR(NULL, Timeframe_Dn, ATR_Period_Dn, 1);
               //---- Getting the current price
               open = iOpen(Symbol(), Timeframe_Dn, 0);
               //---- Calculating the distance to the Stop Loss
               Level = ATR * _TRAILINGSTOP_Dn;
               //---- Checking the distance to the Stop Loss against the minimum value
               if (Level < _LevMinimum_Dn)
                        Level = _LevMinimum_Dn;
               //---- Getting the absolute Trailing Stop value          
               dTrailingStop_Dn = open + Level;
               //---- Correcting the absolute Trailing Stop value, 
                        // given the direction of the trade (for position 
                           // modification functions the value of the cmd variable is inverse!)
               dGhartVelueCorrect(OP_BUY, dTrailingStop_Dn);
              }                                         
          }
         
         //----+ DEAL EXECUTION
         if (!CloseSellOrder1_(SELL_Stop, 2))
                                      return(-1);
         //----                                 
         if (!dOpenSellOrder1_(SELL_Sign, 2, TradeTimeLevel_Dn,
               Money_Management_Dn, 5, dStopLoss_Dn, dTakeProfit_Dn))
                                                             return(-1);
         //----
         if (!dMake_SellTrailingStop_(TrailSignal_Dn, 2, 
                          TradeTimeLevel_Dn, dTrailingStop_Dn))
                                                       return(-1);
       }
    //----
    return(0);
//----+
  }
//Version  January 7, 2007 Final
//+X================================================================X+
//|                                             JJMASeries1(Exp).mqh |
//|                       JMA code: Copyright  1998, Jurik Research |
//|                                          http://www.jurikres.com | 
//|             MQL4 JJMASeries1: Copyright  2006, Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+X================================================================X+ 
  /*
  +-------------------------------------- <<< JJMASeries1() function >>> ----------------------------------------------+

  +-----------------------------------------+ <<< Purpose >>> +----------------------------------------------------+

  The JJMASeries1() function is intended for using the JMA algorithm when writing EAs in order to replace the calculation 
  of the classical smoothing with this algorithm. The file should be placed in the MetaTrader\experts\include\ folder. Please note
  that if nJMA1_bar is greater than nJMA1_MaxBar, the JJMASeries1() function will return zero! on that bar!
  So this value cannot be in the denominator of any fraction when calculating the indicator! This
  version of the JJMASeries1() function does not support EAs when used in custom indicators called
  by an Expert Advisor.  This version of the JJMASeries1() function supports EAs when used in the code of an indicator
  that is added to the code of an Expert Advisor, along with all loop operators and variables! When writing EAs
  using the JJMASeries1() function, it is not recommended to name variables in such a way that they will start with nJMA1_... or dJMA1_...
  The JJMASeries1() function can be used within other custom functions but in this case
  you should bear in mind that in calling such custom function, each call of JJMASeries1()
  should have its unique number nJMA1_number.  This version of the JJMASeries1() function should be used in EAs
  working with the first bar. The JJMASeries1() function can be used within other custom
  functions but in this case you should bear in mind that in calling such custom function, each
  call of JJMASeries1() should have its unique number (nJMA1_number). 
  
  
  +-------------------------------------+ <<< Input parameters >>> +-------------------------------------------------+

  nJMA1_number - JJMASeries1() function call number. (0, 1, 2, 3, etc.)
  nJMA1_dinJ   - parameter that allows you to change the nJMA1_Length and nJMA1_Phase parameters on each bar. 0 - any parameter 
                 changes are not allows, any other value indicates permission.
  nJMA1_MaxBar - the maximum value that can be taken on by the calculated bar number.    It is usually equal to 
                 Bars-1-period; where "period" is the number of bars on which the initial dJMA1_series value is not 
                 calculated;
  nJMA1_limit  - number of uncounted bars or the number of the last uncounted bar,    
  nJMA1_Length - depth of smoothing
  nJMA1_Phase  - parameter that varies within the range -100 ... +100, impacts the transitional process quality;
  dJMA1_series - Input parameter based on which the JJMASeries1 is calculated;
  nJMA1_bar    - number of the calculated bar; the loop operator changes the parameter from the maximum value to 
                 the first one!    That said, its maximum value should always be equal to the nJMA1_limit parameter value!!!

  +------------------------------------+ <<< Output parameters >>> +-------------------------------------------------+

  JJMASeries1()- dJMA1_JMA function value. If nJMA1_bar is greater than nJMA1_MaxBar-30, the JJMASeries1() function 
                 always returns zero!!!
  nJMA1_reset  - parameter that by reference returns the value different from 0, if an error occurred in the function calculation,
                 0 - if the calculation was successful. This parameter can only be a variable but not a value!!!!
                 
  +-----------------------------------+ <<< Function initialization >>> +-----------------------------------------------+
  
  Before calling the JJMASeries1() function, internal buffer variables of the function should be resized in the
  initialization block. For this purpose, you need to call the JJMASeries1() function through the auxiliary
  JJMASeries1Resize() function using the following parameters: JJMASeries1Resize(nJMA1_number+1);
  nJMA1_number(MaxJMA.number) should be made equal to the number of JJMASeries1() function calls, i.e. one more than 
  the maximum nJMA1_number. 
  
  +--------------------------------------+ <<< Indication of errors >>> +-------------------------------------------------+
  
  When debugging indicators and EAs, their codes may contain errors the cause of which should be determined using the log
  file.  The JJMASeries1() function writes all errors to the log file under \MetaTrader\EXPERTS\LOGS\. If before calling the
  JJMASeries1() function, an MQL4 error occurs in the code preceding the function, the function will write the error code and description
  to the log file. If when executing the JJMASeries1() function, an MQL4 error occurs in the JJMASeries1() algorithm,
  the function will also write the code error and description to the log file. In case of incorrect setting of the
  JJMASeries1() function call number, nJMA1_number, or incorrectly determined size of buffer variables nJJMAResize_Size, the log file 
  will contain the relevant messages regarding these parameters being incorrectly determined. The log file also contains information regarding the incorrectly
  determined nJMA1_limit parameter.  If during execution of the initialization function init(), an error occurs when resizing
  buffer variables of the JJMASeries1() function, the JJMASeries1Resize() function will write the relevant information regarding
  the failure to resize buffer variables to the log file. If when calling the JJMASeries1() function through an external loop
  operator, the correct sequence of nJMA1_bar parameter modification was disrupted, the log file will also contain
  the relevant information. It should be noted that some program code errors will give rise to further errors in the code execution,
  so if the JJMASeries1() function adds several errors to the log around the same time, they should be fixed according
  to the time of their occurrence. In a correctly written Expert Advisor, the JJMASeries1() function can add entries to the log file only
  in case of errors in the operating system work.  The only exception is writing of changes in buffer variable sizes upon
  reloading an Expert Advisor at every init() function call. 
  */
//+X================================================================X+
//|  JJMASeries1() function                                          |
//+X================================================================X+

//----++ <<< Declaration of variables >>> 
double dJMA1_f18[1],dJMA1_f38[1],dJMA1_fA8[1],dJMA1_fC0[1],dJMA1_fC8[1],dJMA1_s8[1],dJMA1_s18[1],dJMA1_v1[1],dJMA1_v2[1];
double dJMA1_v3[1],dJMA1_f90[1],dJMA1_f78[1],dJMA1_f88[1],dJMA1_f98[1],dJMA1_JMA[1],dJMA1_list[1][128],dJMA1_ring1[1][128];
double dJMA1_ring2[1][11],dJMA1_buffer[1][62],dJMA1_Kg[1],dJMA1_Pf[1];
//--+
int    nJMA1_s28[1],nJMA1_s30[1],nJMA1_s38[1],nJMA1_s40[1],nJMA1_s48[1],nJMA1_f0[1],nJMA1_s50[1],nJMA1_s70[1],nJMA1_LP2[1];   
int    nJMA1_LP1[1],nJMA1_Test[1];
 
//--+ +-------------------------------------------------------------------------------------------------------------+
double dJMA1_fA0,dJMA1_vv,dJMA1_v4,dJMA1_f70,dJMA1_s20,dJMA1_s10,dJMA1_fB0,dJMA1_fD0,dJMA1_f8,dJMA1_f60,dJMA1_f20,dJMA1_f28;
double dJMA1_f30,dJMA1_f40,dJMA1_f48,dJMA1_f58,dJMA1_f68;
//--+
int    nJMA1_v5,nJMA1_v6,nJMA1_fE0,nJMA1_fD8,nJMA1_fE8,nJMA1_val,nJMA1_s58,nJMA1_s60,nJMA1_s68,nJMA1_size;
int    nJMA1_ii,nJMA1_jj,nJMA1_n,nJMA1_Error,nJMA1_Resize;

//----++ <<< Declaration of the JJMASeries1() function >>> 

double JJMASeries1
(
int nJMA1_number, int nJMA1_din,       int nJMA1_MaxBar, int nJMA1_limit,
int nJMA1_Phase,  int nJMA1_Length, double dJMA1_series, int nJMA1_bar,   int& nJMA1_reset
)
//----++
{
nJMA1_n=nJMA1_number;

nJMA1_reset=1;

//=====+ <<< Checking for errors >>> ==================================================================+

if (nJMA1_bar==nJMA1_limit)
 {
  //----++ checking for the JJMASeries1() function initialization
  if(nJMA1_Resize<1)
   {
    Print(StringConcatenate("JJMASeries1 number =", nJMA1_n,
         ". Buffer variables have not been resized using the JJMASeries1Resize() function"));
    if(nJMA1_Resize==0)
        Print(StringConcatenate("JJMASeries1 number =", nJMA1_n,
                ". The JJMASeries1Resize() function call should be added to the initialization block"));
    return(0.0);
   }
  //----++ checking for error in the execution of the program code preceding the JJMASeries1() function
  nJMA1_Error=GetLastError();
  if(nJMA1_Error>4000)
   {
    Print(StringConcatenate("JJMASeries1 number =", nJMA1_n,
         ". An error occurred in the code preceding the JJMASeries1() function call number = ", nJMA1_n," error!!!"));
    Print(StringConcatenate("JJMASeries1 number =", nJMA1_n, ". ",JMA_ErrDescr1(nJMA1_Error)));  
   } 
                                                   
  //----++ checking for error in setting the nJMA1_number and nJMA1Resize.Number variables
  nJMA1_size=ArraySize(dJMA1_JMA);
  if (nJMA1_size< nJMA1_n) 
   {
    Print(StringConcatenate("JJMASeries1 number =", nJMA1_n,
          ". Error!!! Invalid value of nJMA1_number=",
                                                         nJMA1_n, " of the JJMASeries1() function"));
    Print(StringConcatenate("JJMASeries1 number =", nJMA1_n,
          ". Or invalid value of nJJMAResize_Size=",
                                                nJMA1_size, " of the JJMASeries1Resize() function"));
    return(0.0);
   }
 }
//----++ +============================================================================================+ 

if (nJMA1_bar> nJMA1_MaxBar){nJMA1_reset=0;return(0.0);}
if((nJMA1_bar==nJMA1_MaxBar)||(nJMA1_din!=0)) 
  {
   //----++ <<< Calculation of coefficients  >>> 
   nJMA1_Test[nJMA1_n]=1;
   double nJMA1_Dr,nJMA1_Ds,nJMA1_Dl;
   if(nJMA1_Length < 1.0000000002) nJMA1_Dr = 0.0000000001;
   else nJMA1_Dr= (nJMA1_Length - 1.0) / 2.0;
   if((nJMA1_Phase >= -100)&&(nJMA1_Phase <= 100))dJMA1_Pf[nJMA1_n] = nJMA1_Phase/100.0 + 1.5;
   if (nJMA1_Phase > 100) dJMA1_Pf[nJMA1_n] = 2.5;
   if (nJMA1_Phase < -100) dJMA1_Pf[nJMA1_n] = 0.5;
   nJMA1_Dr = nJMA1_Dr * 0.9; dJMA1_Kg[nJMA1_n] = nJMA1_Dr/(nJMA1_Dr + 2.0);
   nJMA1_Ds=MathSqrt(nJMA1_Dr);nJMA1_Dl=MathLog(nJMA1_Ds); 
   dJMA1_v1[nJMA1_n]= nJMA1_Dl;dJMA1_v2[nJMA1_n] = dJMA1_v1[nJMA1_n];
   if((dJMA1_v1[nJMA1_n] / MathLog(2.0)) + 2.0 < 0.0) dJMA1_v3[nJMA1_n]= 0.0;
   else dJMA1_v3[nJMA1_n]=(dJMA1_v2[nJMA1_n]/MathLog(2.0))+ 2.0;
   dJMA1_f98[nJMA1_n]= dJMA1_v3[nJMA1_n];
   if( dJMA1_f98[nJMA1_n] >= 2.5 ) dJMA1_f88[nJMA1_n] = dJMA1_f98[nJMA1_n] - 2.0;
   else dJMA1_f88[nJMA1_n]= 0.5;
   dJMA1_f78[nJMA1_n]= nJMA1_Ds * dJMA1_f98[nJMA1_n]; 
   dJMA1_f90[nJMA1_n]= dJMA1_f78[nJMA1_n] / (dJMA1_f78[nJMA1_n] + 1.0);
   //----++
  }
//--+

if (nJMA1_LP1[nJMA1_n]<61){nJMA1_LP1[nJMA1_n]++; dJMA1_buffer[nJMA1_n][nJMA1_LP1[nJMA1_n]]=dJMA1_series;}
if (nJMA1_LP1[nJMA1_n]>30)
{
//++++++++++++++++++
if (nJMA1_f0[nJMA1_n] != 0)
{
nJMA1_f0[nJMA1_n] = 0; 
nJMA1_v5 = 1;
nJMA1_fD8 = nJMA1_v5*30;
if (nJMA1_fD8 == 0) dJMA1_f38[nJMA1_n] = dJMA1_series; else dJMA1_f38[nJMA1_n] = dJMA1_buffer[nJMA1_n][1];
dJMA1_f18[nJMA1_n] = dJMA1_f38[nJMA1_n];
if (nJMA1_fD8 > 29) nJMA1_fD8 = 29;
}
else nJMA1_fD8 = 0;
for(nJMA1_ii=nJMA1_fD8; nJMA1_ii>=0; nJMA1_ii--)
{
nJMA1_val=31-nJMA1_ii;
if (nJMA1_ii == 0) dJMA1_f8 = dJMA1_series; else dJMA1_f8 = dJMA1_buffer[nJMA1_n][nJMA1_val];
dJMA1_f28 = dJMA1_f8 - dJMA1_f18[nJMA1_n]; dJMA1_f48 = dJMA1_f8 - dJMA1_f38[nJMA1_n];
if (MathAbs(dJMA1_f28) > MathAbs(dJMA1_f48)) dJMA1_v2[nJMA1_n] = MathAbs(dJMA1_f28); else dJMA1_v2[nJMA1_n] = MathAbs(dJMA1_f48);
dJMA1_fA0 = dJMA1_v2[nJMA1_n]; dJMA1_vv = dJMA1_fA0 + 0.0000000001; //{1.0e-10;}
if (nJMA1_s48[nJMA1_n] <= 1) nJMA1_s48[nJMA1_n] = 127; else nJMA1_s48[nJMA1_n] = nJMA1_s48[nJMA1_n] - 1;
if (nJMA1_s50[nJMA1_n] <= 1) nJMA1_s50[nJMA1_n] = 10;  else nJMA1_s50[nJMA1_n] = nJMA1_s50[nJMA1_n] - 1;
if (nJMA1_s70[nJMA1_n] < 128) nJMA1_s70[nJMA1_n] = nJMA1_s70[nJMA1_n] + 1;
dJMA1_s8[nJMA1_n] = dJMA1_s8[nJMA1_n] + dJMA1_vv - dJMA1_ring2[nJMA1_n][nJMA1_s50[nJMA1_n]];
dJMA1_ring2[nJMA1_n][nJMA1_s50[nJMA1_n]] = dJMA1_vv;
if (nJMA1_s70[nJMA1_n] > 10) dJMA1_s20 = dJMA1_s8[nJMA1_n] / 10.0; else dJMA1_s20 = dJMA1_s8[nJMA1_n] / nJMA1_s70[nJMA1_n];
if (nJMA1_s70[nJMA1_n] > 127)
{
dJMA1_s10 = dJMA1_ring1[nJMA1_n][nJMA1_s48[nJMA1_n]];
dJMA1_ring1[nJMA1_n][nJMA1_s48[nJMA1_n]] = dJMA1_s20; nJMA1_s68 = 64; nJMA1_s58 = nJMA1_s68;
while (nJMA1_s68 > 1)
{
if (dJMA1_list[nJMA1_n][nJMA1_s58] < dJMA1_s10){nJMA1_s68 = nJMA1_s68 *0.5; nJMA1_s58 = nJMA1_s58 + nJMA1_s68;}
else 
if (dJMA1_list[nJMA1_n][nJMA1_s58]<= dJMA1_s10) nJMA1_s68 = 1; else{nJMA1_s68 = nJMA1_s68 *0.5; nJMA1_s58 = nJMA1_s58 - nJMA1_s68;}
}
}
else
{
dJMA1_ring1[nJMA1_n][nJMA1_s48[nJMA1_n]] = dJMA1_s20;
if  (nJMA1_s28[nJMA1_n] + nJMA1_s30[nJMA1_n] > 127){nJMA1_s30[nJMA1_n] = nJMA1_s30[nJMA1_n] - 1; nJMA1_s58 = nJMA1_s30[nJMA1_n];}
else{nJMA1_s28[nJMA1_n] = nJMA1_s28[nJMA1_n] + 1; nJMA1_s58 = nJMA1_s28[nJMA1_n];}
if  (nJMA1_s28[nJMA1_n] > 96) nJMA1_s38[nJMA1_n] = 96; else nJMA1_s38[nJMA1_n] = nJMA1_s28[nJMA1_n];
if  (nJMA1_s30[nJMA1_n] < 32) nJMA1_s40[nJMA1_n] = 32; else nJMA1_s40[nJMA1_n] = nJMA1_s30[nJMA1_n];
}
nJMA1_s68 = 64; nJMA1_s60 = nJMA1_s68;
while (nJMA1_s68 > 1)
{
if (dJMA1_list[nJMA1_n][nJMA1_s60] >= dJMA1_s20)
{
if (dJMA1_list[nJMA1_n][nJMA1_s60 - 1] <= dJMA1_s20) nJMA1_s68 = 1; else {nJMA1_s68 = nJMA1_s68 *0.5; nJMA1_s60 = nJMA1_s60 - nJMA1_s68; }
}
else{nJMA1_s68 = nJMA1_s68 *0.5; nJMA1_s60 = nJMA1_s60 + nJMA1_s68;}
if ((nJMA1_s60 == 127) && (dJMA1_s20 > dJMA1_list[nJMA1_n][127])) nJMA1_s60 = 128;
}
if (nJMA1_s70[nJMA1_n] > 127)
{
if (nJMA1_s58 >= nJMA1_s60)
{
if ((nJMA1_s38[nJMA1_n] + 1 > nJMA1_s60) && (nJMA1_s40[nJMA1_n] - 1 < nJMA1_s60)) dJMA1_s18[nJMA1_n] = dJMA1_s18[nJMA1_n] + dJMA1_s20;
else 
if ((nJMA1_s40[nJMA1_n] + 0 > nJMA1_s60) && (nJMA1_s40[nJMA1_n] - 1 < nJMA1_s58)) dJMA1_s18[nJMA1_n] 
= dJMA1_s18[nJMA1_n] + dJMA1_list[nJMA1_n][nJMA1_s40[nJMA1_n] - 1];
}
else
if (nJMA1_s40[nJMA1_n] >= nJMA1_s60) {if ((nJMA1_s38[nJMA1_n] + 1 < nJMA1_s60) && (nJMA1_s38[nJMA1_n] + 1 > nJMA1_s58)) dJMA1_s18[nJMA1_n] 
= dJMA1_s18[nJMA1_n] + dJMA1_list[nJMA1_n][nJMA1_s38[nJMA1_n] + 1]; }
else if  (nJMA1_s38[nJMA1_n] + 2 > nJMA1_s60) dJMA1_s18[nJMA1_n] = dJMA1_s18[nJMA1_n] + dJMA1_s20; 
else if ((nJMA1_s38[nJMA1_n] + 1 < nJMA1_s60) && (nJMA1_s38[nJMA1_n] + 1 > nJMA1_s58)) dJMA1_s18[nJMA1_n] 
= dJMA1_s18[nJMA1_n] + dJMA1_list[nJMA1_n][nJMA1_s38[nJMA1_n] + 1];
if (nJMA1_s58 > nJMA1_s60)
{
if ((nJMA1_s40[nJMA1_n] - 1 < nJMA1_s58) && (nJMA1_s38[nJMA1_n] + 1 > nJMA1_s58)) dJMA1_s18[nJMA1_n] = dJMA1_s18[nJMA1_n] - dJMA1_list[nJMA1_n][nJMA1_s58];
else 
if ((nJMA1_s38[nJMA1_n]     < nJMA1_s58) && (nJMA1_s38[nJMA1_n] + 1 > nJMA1_s60)) dJMA1_s18[nJMA1_n] = dJMA1_s18[nJMA1_n] - dJMA1_list[nJMA1_n][nJMA1_s38[nJMA1_n]];
}
else
{
if ((nJMA1_s38[nJMA1_n] + 1 > nJMA1_s58) && (nJMA1_s40[nJMA1_n] - 1 < nJMA1_s58)) dJMA1_s18[nJMA1_n] = dJMA1_s18[nJMA1_n] - dJMA1_list[nJMA1_n][nJMA1_s58];
else
if ((nJMA1_s40[nJMA1_n] + 0 > nJMA1_s58) && (nJMA1_s40[nJMA1_n] - 0 < nJMA1_s60)) dJMA1_s18[nJMA1_n] = dJMA1_s18[nJMA1_n] - dJMA1_list[nJMA1_n][nJMA1_s40[nJMA1_n]];
}
}
if (nJMA1_s58 <= nJMA1_s60)
{
if (nJMA1_s58 >= nJMA1_s60)
{
dJMA1_list[nJMA1_n][nJMA1_s60] = dJMA1_s20;
}
else
{
for( nJMA1_jj = nJMA1_s58 + 1; nJMA1_jj<=nJMA1_s60 - 1 ;nJMA1_jj++)dJMA1_list[nJMA1_n][nJMA1_jj - 1] = dJMA1_list[nJMA1_n][nJMA1_jj];
dJMA1_list[nJMA1_n][nJMA1_s60 - 1] = dJMA1_s20;
}
}
else
{
for( nJMA1_jj = nJMA1_s58 - 1; nJMA1_jj>=nJMA1_s60 ;nJMA1_jj--) dJMA1_list[nJMA1_n][nJMA1_jj + 1] = dJMA1_list[nJMA1_n][nJMA1_jj];
dJMA1_list[nJMA1_n][nJMA1_s60] = dJMA1_s20;
}
if (nJMA1_s70[nJMA1_n] <= 127)
{
dJMA1_s18[nJMA1_n] = 0;
for( nJMA1_jj = nJMA1_s40[nJMA1_n] ; nJMA1_jj<=nJMA1_s38[nJMA1_n] ;nJMA1_jj++) dJMA1_s18[nJMA1_n] = dJMA1_s18[nJMA1_n] + dJMA1_list[nJMA1_n][nJMA1_jj];
}
dJMA1_f60 = dJMA1_s18[nJMA1_n] / (nJMA1_s38[nJMA1_n] - nJMA1_s40[nJMA1_n] + 1.0);
if (nJMA1_LP2[nJMA1_n] + 1 > 31) nJMA1_LP2[nJMA1_n] = 31; else nJMA1_LP2[nJMA1_n] = nJMA1_LP2[nJMA1_n] + 1;
if (nJMA1_LP2[nJMA1_n] <= 30)
{
if (dJMA1_f28 > 0.0) dJMA1_f18[nJMA1_n] = dJMA1_f8; else dJMA1_f18[nJMA1_n] = dJMA1_f8 - dJMA1_f28 * dJMA1_f90[nJMA1_n];
if (dJMA1_f48 < 0.0) dJMA1_f38[nJMA1_n] = dJMA1_f8; else dJMA1_f38[nJMA1_n] = dJMA1_f8 - dJMA1_f48 * dJMA1_f90[nJMA1_n];
dJMA1_JMA[nJMA1_n] = dJMA1_series;
if (nJMA1_LP2[nJMA1_n]!=30) continue;
if (nJMA1_LP2[nJMA1_n]==30)
{
dJMA1_fC0[nJMA1_n] = dJMA1_series;
if ( MathCeil(dJMA1_f78[nJMA1_n]) >= 1) dJMA1_v4 = MathCeil(dJMA1_f78[nJMA1_n]); else dJMA1_v4 = 1.0;

if(dJMA1_v4>0)nJMA1_fE8 = MathFloor(dJMA1_v4);else{if(dJMA1_v4<0)nJMA1_fE8 = MathCeil (dJMA1_v4);else nJMA1_fE8 = 0.0;}

if (MathFloor(dJMA1_f78[nJMA1_n]) >= 1) dJMA1_v2[nJMA1_n] = MathFloor(dJMA1_f78[nJMA1_n]); else dJMA1_v2[nJMA1_n] = 1.0;

if(dJMA1_v2[nJMA1_n]>0)nJMA1_fE0 = MathFloor(dJMA1_v2[nJMA1_n]);else{if(dJMA1_v2[nJMA1_n]<0)nJMA1_fE0 = MathCeil (dJMA1_v2[nJMA1_n]);else nJMA1_fE0 = 0.0;}

if (nJMA1_fE8== nJMA1_fE0) dJMA1_f68 = 1.0; else {dJMA1_v4 = nJMA1_fE8 - nJMA1_fE0; dJMA1_f68 = (dJMA1_f78[nJMA1_n] - nJMA1_fE0) / dJMA1_v4;}
if (nJMA1_fE0 <= 29) nJMA1_v5 = nJMA1_fE0; else nJMA1_v5 = 29;
if (nJMA1_fE8 <= 29) nJMA1_v6 = nJMA1_fE8; else nJMA1_v6 = 29;
dJMA1_fA8[nJMA1_n] = (dJMA1_series - dJMA1_buffer[nJMA1_n][nJMA1_LP1[nJMA1_n] - nJMA1_v5]) * (1.0 - dJMA1_f68) / nJMA1_fE0 + (dJMA1_series 
- dJMA1_buffer[nJMA1_n][nJMA1_LP1[nJMA1_n] - nJMA1_v6]) * dJMA1_f68 / nJMA1_fE8;
}
}
else
{
if (dJMA1_f98[nJMA1_n] >= MathPow(dJMA1_fA0/dJMA1_f60, dJMA1_f88[nJMA1_n])) dJMA1_v1[nJMA1_n] = MathPow(dJMA1_fA0/dJMA1_f60, dJMA1_f88[nJMA1_n]);
else dJMA1_v1[nJMA1_n] = dJMA1_f98[nJMA1_n];
if (dJMA1_v1[nJMA1_n] < 1.0) dJMA1_v2[nJMA1_n] = 1.0;
else
{if(dJMA1_f98[nJMA1_n] >= MathPow(dJMA1_fA0/dJMA1_f60, dJMA1_f88[nJMA1_n])) dJMA1_v3[nJMA1_n] = MathPow(dJMA1_fA0/dJMA1_f60, dJMA1_f88[nJMA1_n]);
else dJMA1_v3[nJMA1_n] = dJMA1_f98[nJMA1_n]; dJMA1_v2[nJMA1_n] = dJMA1_v3[nJMA1_n];}
dJMA1_f58 = dJMA1_v2[nJMA1_n]; dJMA1_f70 = MathPow(dJMA1_f90[nJMA1_n], MathSqrt(dJMA1_f58));
if (dJMA1_f28 > 0.0) dJMA1_f18[nJMA1_n] = dJMA1_f8; else dJMA1_f18[nJMA1_n] = dJMA1_f8 - dJMA1_f28 * dJMA1_f70;
if (dJMA1_f48 < 0.0) dJMA1_f38[nJMA1_n] = dJMA1_f8; else dJMA1_f38[nJMA1_n] = dJMA1_f8 - dJMA1_f48 * dJMA1_f70;
}
}
if (nJMA1_LP2[nJMA1_n] >30)
{
dJMA1_f30 = MathPow(dJMA1_Kg[nJMA1_n], dJMA1_f58);
dJMA1_fC0[nJMA1_n] =(1.0 - dJMA1_f30) * dJMA1_series + dJMA1_f30 * dJMA1_fC0[nJMA1_n];
dJMA1_fC8[nJMA1_n] =(dJMA1_series - dJMA1_fC0[nJMA1_n]) * (1.0 - dJMA1_Kg[nJMA1_n]) + dJMA1_Kg[nJMA1_n] * dJMA1_fC8[nJMA1_n];
dJMA1_fD0 = dJMA1_Pf[nJMA1_n] * dJMA1_fC8[nJMA1_n] + dJMA1_fC0[nJMA1_n];
dJMA1_f20 = dJMA1_f30 *(-2.0);
dJMA1_f40 = dJMA1_f30 * dJMA1_f30;
dJMA1_fB0 = dJMA1_f20 + dJMA1_f40 + 1.0;
dJMA1_fA8[nJMA1_n] =(dJMA1_fD0 - dJMA1_JMA[nJMA1_n]) * dJMA1_fB0 + dJMA1_f40 * dJMA1_fA8[nJMA1_n];
dJMA1_JMA[nJMA1_n] = dJMA1_JMA[nJMA1_n] + dJMA1_fA8[nJMA1_n];
}
}
//++++++++++++++++++
if (nJMA1_LP1[nJMA1_n] <=30)dJMA1_JMA[nJMA1_n]=0.0;
//----+ 

//----++ checking for error in the execution of the JJMASeries1() function code
nJMA1_Error=GetLastError();
if(nJMA1_Error>4000)
  {
    Print(StringConcatenate("JJMASeries1 number =", nJMA1_n, 
                         ". Error when executing the JJMASeries1() function!!!"));
    Print(StringConcatenate("JJMASeries1 number =", nJMA1_n, ". ", JMA_ErrDescr1(nJMA1_Error)));   
    return(0.0);
  }

nJMA1_reset=0;
return(dJMA1_JMA[nJMA1_n]);
//----+  End of JJMASeries1() function calculations
}
//+X================================================================X+
//| JJMASeries1Resize() function                                     |
//+X================================================================X+
// JJMASeries1Resize is an additional function for resizing      |
// and initialization of buffer variables of the JJMASeries1 function. |
// Call example: JJMASeries1Resize(5); where 5 is the number    |
// of calls of JJMASeries1() in the text of the indicator. This call     |
// of the JJMASeries1Resize function should be added                      |
// to the initialization block of a custom indicator or EA    |                         
//+X----------------------------------------------------------------X+
int JJMASeries1Resize(int nJJMAResize_Size)
 {
//----+
  int kkk, nJJMAResize_reset, nJJMAResize_cycle;
  //--+
  while(nJJMAResize_cycle == 0)
   {
    //----++ <<< resizing buffer variables >>> +--------------------------+
    if(ArrayResize(dJMA1_list,   nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(dJMA1_ring1,  nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(dJMA1_ring2,  nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(dJMA1_buffer, nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(dJMA1_Kg,     nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(dJMA1_Pf,     nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(dJMA1_f18,    nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(dJMA1_f38,    nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(dJMA1_fA8,    nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(dJMA1_fC0,    nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(dJMA1_fC8,    nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(dJMA1_s8,     nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(dJMA1_s18,    nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(dJMA1_JMA,    nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(nJMA1_s50,    nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(nJMA1_s70,    nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(nJMA1_LP2,    nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(nJMA1_LP1,    nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(nJMA1_s38,    nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(nJMA1_s40,    nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(nJMA1_s48,    nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(dJMA1_v1,     nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(dJMA1_v2,     nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(dJMA1_v3,     nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(dJMA1_f90,    nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(dJMA1_f78,    nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(dJMA1_f88,    nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(dJMA1_f98,    nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(nJMA1_s28,    nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(nJMA1_s30,    nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(nJMA1_f0,     nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    if(ArrayResize(nJMA1_Test,   nJJMAResize_Size) == 0){nJJMAResize_reset = -1; break;}
    //+--------------------------------------------------------------------------------+
    nJJMAResize_cycle = 1;
   }
  //--+
  if (nJJMAResize_reset == -1)
   {
    Print(StringConcatenate("JJMASeries1Resize: Error!!!",
               " Failed to resize buffer variables of the JJMASeries1() function!!!"));
    //----                                                                                                                                                                                                               
    nJMA1_Resize = -2;
    return(0);
   }
  else  
   {
    Print(StringConcatenate("JJMASeries1Resize: JJMASeries1 Size = ", nJJMAResize_Size, ""));

    //----
    ArrayInitialize(nJMA1_f0,   1);
    ArrayInitialize(nJMA1_s28, 63);
    ArrayInitialize(nJMA1_s30, 64);
    //----
    for(int rrr = 0; rrr < nJJMAResize_Size; rrr++)
     {
       for(kkk=0; kkk <= nJMA1_s28[rrr]; kkk++)
                                dJMA1_list[rrr][kkk] = -1000000.0;
                                
       for(kkk = nJMA1_s30[rrr]; kkk <= 127; kkk++)
                                dJMA1_list[rrr][kkk] = +1000000.0;
     }
    //----
    nJMA1_Resize = nJJMAResize_Size;
    return(nJJMAResize_Size);
   }  
//----+
 }
/*
//+X================================================================X+
//| JJMASeries1Alert() function                                      |
//+X================================================================X+
/*                                                                   |
 JJMASeries1Alert is an additional function for indication   |
 of error when setting external variables nJMA1_Length and nJMA1_Phase   |
 of the JJMASeries1 function.                                                |
  ----------------------- input parameters  ------------------------| 
 Number                                                              |
 ExternVar - value of the external variable for the nJMA1_Length parameter   | 
       name - name of the external variable for the nJMA1_Phase parameter if   |
 Number = 0 or nJMA1_Phase if Number = 1.                            |
  -------------------------- Application example  -------------------|
  int init()                                                         |
  //----                                                             |
  Some initialization of variables and buffers can be here           |
                                                                     |                                                                                               
  //---- setting alerts for                                          |
  //---- invalid values of external variables                        |
  JJMASeries1Alert(0, "Length1", Length1);                           |
  JJMASeries1Alert(0, "Length2", Length2);                           |
  JJMASeries1Alert(1, "Phase1", Phase1);                             |                                                            
  JJMASeries1Alert(1, "Phase2", Phase2);                             |                                                          
  //---- initialization complete                                     |
  return(0);                                                         |
 }                                                                   |
//+X----------------------------------------------------------------X+
*/
void JJMASeries1Alert(int Number, string name, int ExternVar)
 {
//----+
  //---- setting alerts for invalid values of input parameters 
  if (Number == 0)
    if (ExternVar < 1)
       Print(StringConcatenate
         ("The ", name, " parameter must not be less than 1",
              " You have entered invalid ", ExternVar, " the value of 1 will be used"));
  
  if (Number == 1)
   {
    if (ExternVar < -100 || ExternVar > 100)
       Print(StringConcatenate
         ("The ", name, " parameter must be from -100 to +100", 
            " You have entered invalid ", ExternVar, " the value of -100 will be used"));
   }
   
  if (Number != 0 && Number != 1)
       Print(StringConcatenate
         ("The Number parameter can only be equal to 0 and 1", 
                                    " You have entered invalid ", Number, "!!!"));
//----+
 }
// Russian translation provided by Nikolay Kositsin, 17.07.2008 
//+X================================================================X+
//|                                      JMA_ErrDescr1(MQL4_RUS).mqh |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+X================================================================X+
/*                                                                   |
 by the MQL4 error code the JMA_ErrDescr1() function returns the string   |
 containing the error code and description.                                |
  -------------------- Application example  ----------------------- | 
 int Error = GetLastError();                                         |
 if (Error > 4000)                                                   |
        Print(JMA_ErrDescr1(Error));     *///                        |
//+X----------------------------------------------------------------X+
string JMA_ErrDescr1(int error_code)
 {
  string error_string;
//----
  switch(error_code)
    {
     //---- Codes returned by the trade server
     case    0:                                                                                                                                 break;
     case    1: error_string = StringConcatenate("Error code = ", error_code, ". No errors");                                                  break;
     case    2: error_string = StringConcatenate("Error code = ", error_code, ". Common error");                                                break;
     case    3: error_string = StringConcatenate("Error code = ", error_code, ". Invalid trade parameters");                             break;
     case    4: error_string = StringConcatenate("Error code = ", error_code, ". Trade server is busy");                                       break;
     case    5: error_string = StringConcatenate("Error code = ", error_code, ". Old version of the client terminal");                       break;
     case    6: error_string = StringConcatenate("Error code = ", error_code, ". No connection with trade server");                          break;
     case    7: error_string = StringConcatenate("Error code = ", error_code, ". Not enough rights");                                           break;
     case    8: error_string = StringConcatenate("Error code = ", error_code, ". Too frequent trade server requests");                   break;
     case    9: error_string = StringConcatenate("Error code = ", error_code, ". Malfunctional trade operation");  break;
     case   64: error_string = StringConcatenate("Error code = ", error_code, ". Account disabled");                                           break;
     case   65: error_string = StringConcatenate("Error code = ", error_code, ". Invalid account number");                                    break;
     case  128: error_string = StringConcatenate("Error code = ", error_code, ". Trade timeout");                       break;
     case  129: error_string = StringConcatenate("Error code = ", error_code, ". Invalid price");                                             break;
     case  130: error_string = StringConcatenate("Error code = ", error_code, ". Invalid stops");                                             break;
     case  131: error_string = StringConcatenate("Error code = ", error_code, ". Invalid trade volume");                                   break;
     case  132: error_string = StringConcatenate("Error code = ", error_code, ". Market is closed");                                                break;
     case  133: error_string = StringConcatenate("Error code = ", error_code, ". Trade is disabled");                                          break;
     case  134: error_string = StringConcatenate("Error code = ", error_code, ". Not enough money to perform the operation");                  break;
     case  135: error_string = StringConcatenate("Error code = ", error_code, ". Price changed");                                             break;
     case  136: error_string = StringConcatenate("Error code = ", error_code, ". Off quotes");                                                     break;
     case  137: error_string = StringConcatenate("Error code = ", error_code, ". Broker is busy");                                                break;
     case  138: error_string = StringConcatenate("Error code = ", error_code, ". Requote");                                                  break;
     case  139: error_string = StringConcatenate("Error code = ", error_code, ". Order is locked and being processed");                     break;
     case  140: error_string = StringConcatenate("Error code = ", error_code, ". Long positions only allowed");                                    break;
     case  141: error_string = StringConcatenate("Error code = ", error_code, ". Too many requests");                                      break;
     case  145: error_string = StringConcatenate("Error code = ", error_code, ". Modification denied because the order is too close to market"); break;
     case  146: error_string = StringConcatenate("Error code = ", error_code, ". Trade context is busy");                                  break;
     case  147: error_string = StringConcatenate("Error code = ", error_code, ". Expirations are denied by broker");      break;   
     case  148: error_string = StringConcatenate("Error code = ", error_code,
                                                       ". The number of open and pending orders has reached the limit set by the broker"); break;
     case  149: error_string = StringConcatenate("Error code = ", error_code,
                                                      ". An attempt to open a position opposite to the existing one when hedging is disabled!"); break;
     //---- MQL4 errors 
     case 4000: error_string = StringConcatenate("Error code = ", error_code, ". No errors");                                                  break;
     case 4001: error_string = StringConcatenate("Error code = ", error_code, ". Wrong function pointer");                              break;
     case 4002: error_string = StringConcatenate("Error code = ", error_code, ". Array index is out of range");                 break;
     case 4003: error_string = StringConcatenate("Error code = ", error_code, ". No memory for function call stack");                                break;
     case 4004: error_string = StringConcatenate("Error code = ", error_code, ". Recursive stack overflow");                break;
     case 4005: error_string = StringConcatenate("Error code = ", error_code, ". Not enough stack for parameter");                 break;
     case 4006: error_string = StringConcatenate("Error code = ", error_code, ". No memory for string parameter");                         break;
     case 4007: error_string = StringConcatenate("Error code = ", error_code, ". No memory for temp string");                             break;
     case 4008: error_string = StringConcatenate("Error code = ", error_code, ". Uninitialized string");                                 break;
     case 4009: error_string = StringConcatenate("Error code = ", error_code, ". Uninitialized string in array");                       break;
     case 4010: error_string = StringConcatenate("Error code = ", error_code, ". No memory for string array");                           break;
     case 4011: error_string = StringConcatenate("Error code = ", error_code, ". String too long");                                      break;
     case 4012: error_string = StringConcatenate("Error code = ", error_code, ". Remainder from zero divide");                                  break;
     case 4013: error_string = StringConcatenate("Error code = ", error_code, ". Zero divide");                                             break;
     case 4014: error_string = StringConcatenate("Error code = ", error_code, ". Unknown command");                                         break;
     case 4015: error_string = StringConcatenate("Error code = ", error_code, ". Wrong jump (never generated error)");                break;
     case 4016: error_string = StringConcatenate("Error code = ", error_code, ". Uninitialized array");                                 break;
     case 4017: error_string = StringConcatenate("Error code = ", error_code, ". DLL calls are not allowed");                                     break;
     case 4018: error_string = StringConcatenate("Error code = ", error_code, ". Cannot load the library");                             break;
     case 4019: error_string = StringConcatenate("Error code = ", error_code, ". Cannot call the function");                                  break;
     case 4020: error_string = StringConcatenate("Error code = ", error_code, ". Calls of external library functions are not allowed");            break;
     case 4021: error_string = StringConcatenate("Error code = ", error_code, ". Not enough memory for returned string");     break;
     case 4022: error_string = StringConcatenate("Error code = ", error_code, ". System is busy (never generated error)");                      break;
     case 4050: error_string = StringConcatenate("Error code = ", error_code, ". Invalid number of function parameters");                  break;
     case 4051: error_string = StringConcatenate("Error code = ", error_code, ". Invalid function parameter value");                     break;
     case 4052: error_string = StringConcatenate("Error code = ", error_code, ". String function internal error");                         break;
     case 4053: error_string = StringConcatenate("Error code = ", error_code, ". Array error");                                              break;
     case 4054: error_string = StringConcatenate("Error code = ", error_code, ". Incorrect use of time series array");                break;
     case 4055: error_string = StringConcatenate("Error code = ", error_code, ". Custom indicator error");                         break;
     case 4056: error_string = StringConcatenate("Error code = ", error_code, ". Incompatible arrays");                                        break;
     case 4057: error_string = StringConcatenate("Error code = ", error_code, ". Global variable processing error");                     break;
     case 4058: error_string = StringConcatenate("Error code = ", error_code, ". Global variable not found");                         break;
     case 4059: error_string = StringConcatenate("Error code = ", error_code, ". Function is not allowed in testing mode");                      break;
     case 4060: error_string = StringConcatenate("Error code = ", error_code, ". Function is not confirmed");                                     break;
     case 4061: error_string = StringConcatenate("Error code = ", error_code, ". Mail sending error");                                       break;
     case 4062: error_string = StringConcatenate("Error code = ", error_code, ". String parameter expected");                              break;
     case 4063: error_string = StringConcatenate("Error code = ", error_code, ". Integer parameter expected");                             break;
     case 4064: error_string = StringConcatenate("Error code = ", error_code, ". Double parameter expected");                              break;
     case 4065: error_string = StringConcatenate("Error code = ", error_code, ". Array expected as parameter");                       break;
     case 4066: error_string = StringConcatenate("Error code = ", error_code, ". Requested history data are being updated");      break;
     case 4067: error_string = StringConcatenate("Error code = ", error_code, ". Error when executing trading operation");                     break;
     case 4099: error_string = StringConcatenate("Error code = ", error_code, ". End of file");                                                 break;
     case 4100: error_string = StringConcatenate("Error code = ", error_code, ". Error when working with file");                                  break;
     case 4101: error_string = StringConcatenate("Error code = ", error_code, ". Wrong file name");                                      break;
     case 4102: error_string = StringConcatenate("Error code = ", error_code, ". Too many open files");                               break;
     case 4103: error_string = StringConcatenate("Error code = ", error_code, ". Cannot open the file");                                     break;
     case 4104: error_string = StringConcatenate("Error code = ", error_code, ". Incompatible file access mode");                         break;
     case 4105: error_string = StringConcatenate("Error code = ", error_code, ". No order selected");                                     break;
     case 4106: error_string = StringConcatenate("Error code = ", error_code, ". Unknown symbol");                                          break;
     case 4107: error_string = StringConcatenate("Error code = ", error_code, ". Invalid price parameter for trading function");             break;
     case 4108: error_string = StringConcatenate("Error code = ", error_code, ". Invalid ticket number");                                       break;
     case 4109: error_string = StringConcatenate("Error code = ", error_code, ". Trade is not allowed");                                       break;
     case 4110: error_string = StringConcatenate("Error code = ", error_code, ". Long positions are not allowed");                                break;
     case 4111: error_string = StringConcatenate("Error code = ", error_code, ". Short positions are not allowed");                               break;
     case 4200: error_string = StringConcatenate("Error code = ", error_code, ". Object already exists");                                       break;
     case 4201: error_string = StringConcatenate("Error code = ", error_code, ". Unknown object property requested");                      break;
     case 4202: error_string = StringConcatenate("Error code = ", error_code, ". Object does not exist");                                        break;
     case 4203: error_string = StringConcatenate("Error code = ", error_code, ". Unknown object type");                                     break;
     case 4204: error_string = StringConcatenate("Error code = ", error_code, ". No object name");                                           break;
     case 4205: error_string = StringConcatenate("Error code = ", error_code, ". Object coordinates error");                                    break;
     case 4206: error_string = StringConcatenate("Error code = ", error_code, ". The specified subwindow cannot be found");                                break;
     case 4207: error_string = StringConcatenate("Error code = ", error_code, ". Error when working with the object");                                break;
     default:   error_string = StringConcatenate("Error code = ", error_code, ". unknown error");
    }
  //----
  return(error_string);
 }
//+X----------------------+ <<< The End >>> +-----------------------X+